(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    248672,       5021]
NotebookOptionsPosition[    245624,       4966]
NotebookOutlinePosition[    246028,       4982]
CellTagsIndexPosition[    245985,       4979]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  RowBox[{"NotebookDirectory", "[", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.8508242373666773`*^9, 3.850824241908162*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"25fb2a79-f694-449f-8bd5-bfad109c1593"],

Cell[BoxData["\<\"D:\\\\Projects\\\\pdme\"\>"], "Output",
 CellChangeTimes->{3.8508242422528815`*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"edacc9d0-7054-4bc8-ac81-94fb2d07397e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"dipoleArrow", "[", 
   RowBox[{"{", 
    RowBox[{"p_", ",", " ", "s_"}], "}"}], "]"}], " ", ":=", " ", 
  RowBox[{"Arrow", "[", 
   RowBox[{"{", 
    RowBox[{"s", ",", " ", 
     RowBox[{"s", " ", "+", " ", 
      RowBox[{".5", "p"}]}]}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.839326480255432*^9, 3.839326507409189*^9}, {
  3.8393326970231924`*^9, 3.839332697581507*^9}, {3.839332730515315*^9, 
  3.8393327394291935`*^9}},
 CellLabel->
  "In[111]:=",ExpressionUUID->"eb864b7f-a31b-4a1b-8fa1-d98f247d2bbe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dipoleArrows", "[", "dipoles_", "]"}], " ", ":=", " ", 
  RowBox[{"Map", "[", 
   RowBox[{"dipoleArrow", ",", " ", "dipoles"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.839326512043043*^9, 3.8393265133682904`*^9}, {
  3.839332718852187*^9, 3.839332755021446*^9}},
 CellLabel->
  "In[112]:=",ExpressionUUID->"bc43f605-3de9-4aef-8725-dde23442fda8"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"badDipole", " ", "=", " ", 
   RowBox[{"Normal", "[", 
    RowBox[{
     RowBox[{"badDataClean", "[", 
      RowBox[{"[", "1", "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<pd\>\"", " ", "\[Rule]", " ", 
         RowBox[{"ToExpression", "[", 
          RowBox[{"StringReplace", "[", 
           RowBox[{
            RowBox[{"#", "[", "\"\<actual_dipole_moment\>\"", "]"}], ",", " ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"\"\<(\>\"", " ", "\[Rule]", " ", "\"\<{\>\""}], ",", 
              " ", 
              RowBox[{"\"\<)\>\"", " ", "\[Rule]", " ", "\"\<}\>\""}]}], 
             "}"}]}], "]"}], "]"}]}], " ", ",", " ", 
        RowBox[{"\"\<sd\>\"", " ", "\[Rule]", " ", 
         RowBox[{"ToExpression", "[", 
          RowBox[{"StringReplace", "[", 
           RowBox[{
            RowBox[{"#", "[", "\"\<actual_dipole_position\>\"", "]"}], ",", 
            " ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"\"\<(\>\"", " ", "\[Rule]", " ", "\"\<{\>\""}], ",", 
              " ", 
              RowBox[{"\"\<)\>\"", " ", "\[Rule]", " ", "\"\<}\>\""}]}], 
             "}"}]}], "]"}], "]"}]}]}], " ", "|>"}], " ", "&"}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"goodDipole", " ", "=", " ", 
   RowBox[{"Normal", "[", 
    RowBox[{
     RowBox[{"badDataClean", "[", 
      RowBox[{"[", "1", "]"}], "]"}], "[", 
     RowBox[{
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<pd\>\"", " ", "\[Rule]", " ", 
         RowBox[{"ToExpression", "[", 
          RowBox[{"StringReplace", "[", 
           RowBox[{
            RowBox[{"#", "[", "\"\<actual_dipole_moment\>\"", "]"}], ",", " ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"\"\<(\>\"", " ", "\[Rule]", " ", "\"\<{\>\""}], ",", 
              " ", 
              RowBox[{"\"\<)\>\"", " ", "\[Rule]", " ", "\"\<}\>\""}]}], 
             "}"}]}], "]"}], "]"}]}], " ", ",", " ", 
        RowBox[{"\"\<sd\>\"", " ", "\[Rule]", " ", 
         RowBox[{"ToExpression", "[", 
          RowBox[{"StringReplace", "[", 
           RowBox[{
            RowBox[{"#", "[", "\"\<actual_dipole_position\>\"", "]"}], ",", 
            " ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"\"\<(\>\"", " ", "\[Rule]", " ", "\"\<{\>\""}], ",", 
              " ", 
              RowBox[{"\"\<)\>\"", " ", "\[Rule]", " ", "\"\<}\>\""}]}], 
             "}"}]}], "]"}], "]"}]}]}], " ", "|>"}], " ", "&"}], "]"}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.850827327877841*^9, 3.850827465794386*^9}, {
  3.850827511778657*^9, 3.850827611577742*^9}, {3.850827940039235*^9, 
  3.8508279428650374`*^9}},
 CellLabel->
  "In[118]:=",ExpressionUUID->"5d5515b2-0f43-46c1-b8f7-6247d72c4e09"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"goodDataClean", "=", " ", 
     RowBox[{"goodData", "[", 
      RowBox[{"All", ",", 
       RowBox[{
        RowBox[{"#", " ", "~", "Join", "~", " ", 
         RowBox[{"<|", 
          RowBox[{
           RowBox[{"\"\<bounds_px\>\"", " ", "\[Rule]", " ", 
            RowBox[{"ToExpression", "[", 
             RowBox[{"StringReplace", "[", 
              RowBox[{
               RowBox[{"#", "[", "\"\<bounds_px\>\"", "]"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\"\<(\>\"", " ", "\[Rule]", " ", "\"\<{\>\""}], ",",
                  " ", 
                 RowBox[{"\"\<)\>\"", " ", "\[Rule]", " ", "\"\<}\>\""}]}], 
                "}"}]}], "]"}], "]"}]}], ",", " ", 
           RowBox[{"\"\<bounds_py\>\"", " ", "\[Rule]", " ", 
            RowBox[{"ToExpression", "[", 
             RowBox[{"StringReplace", "[", 
              RowBox[{
               RowBox[{"#", "[", "\"\<bounds_py\>\"", "]"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\"\<(\>\"", " ", "\[Rule]", " ", "\"\<{\>\""}], ",",
                  " ", 
                 RowBox[{"\"\<)\>\"", " ", "\[Rule]", " ", "\"\<}\>\""}]}], 
                "}"}]}], "]"}], "]"}]}], ",", " ", 
           RowBox[{"\"\<bounds_pz\>\"", " ", "\[Rule]", " ", 
            RowBox[{"ToExpression", "[", 
             RowBox[{"StringReplace", "[", 
              RowBox[{
               RowBox[{"#", "[", "\"\<bounds_pz\>\"", "]"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\"\<(\>\"", " ", "\[Rule]", " ", "\"\<{\>\""}], ",",
                  " ", 
                 RowBox[{"\"\<)\>\"", " ", "\[Rule]", " ", "\"\<}\>\""}]}], 
                "}"}]}], "]"}], "]"}]}], ",", " ", 
           RowBox[{"\"\<bounds_sx\>\"", " ", "\[Rule]", " ", 
            RowBox[{"ToExpression", "[", 
             RowBox[{"StringReplace", "[", 
              RowBox[{
               RowBox[{"#", "[", "\"\<bounds_sx\>\"", "]"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\"\<(\>\"", " ", "\[Rule]", " ", "\"\<{\>\""}], ",",
                  " ", 
                 RowBox[{"\"\<)\>\"", " ", "\[Rule]", " ", "\"\<}\>\""}]}], 
                "}"}]}], "]"}], "]"}]}], ",", " ", 
           RowBox[{"\"\<bounds_sy\>\"", " ", "\[Rule]", " ", 
            RowBox[{"ToExpression", "[", 
             RowBox[{"StringReplace", "[", 
              RowBox[{
               RowBox[{"#", "[", "\"\<bounds_sy\>\"", "]"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\"\<(\>\"", " ", "\[Rule]", " ", "\"\<{\>\""}], ",",
                  " ", 
                 RowBox[{"\"\<)\>\"", " ", "\[Rule]", " ", "\"\<}\>\""}]}], 
                "}"}]}], "]"}], "]"}]}], ",", " ", 
           RowBox[{"\"\<bounds_sz\>\"", " ", "\[Rule]", " ", 
            RowBox[{"ToExpression", "[", 
             RowBox[{"StringReplace", "[", 
              RowBox[{
               RowBox[{"#", "[", "\"\<bounds_sz\>\"", "]"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\"\<(\>\"", " ", "\[Rule]", " ", "\"\<{\>\""}], ",",
                  " ", 
                 RowBox[{"\"\<)\>\"", " ", "\[Rule]", " ", "\"\<}\>\""}]}], 
                "}"}]}], "]"}], "]"}]}]}], " ", "|>"}]}], " ", "&"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"badDataClean", "=", " ", 
     RowBox[{"badData", "[", 
      RowBox[{"All", ",", 
       RowBox[{
        RowBox[{"#", " ", "~", "Join", "~", " ", 
         RowBox[{"<|", 
          RowBox[{
           RowBox[{"\"\<bounds_px\>\"", " ", "\[Rule]", " ", 
            RowBox[{"ToExpression", "[", 
             RowBox[{"StringReplace", "[", 
              RowBox[{
               RowBox[{"#", "[", "\"\<bounds_px\>\"", "]"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\"\<(\>\"", " ", "\[Rule]", " ", "\"\<{\>\""}], ",",
                  " ", 
                 RowBox[{"\"\<)\>\"", " ", "\[Rule]", " ", "\"\<}\>\""}]}], 
                "}"}]}], "]"}], "]"}]}], ",", " ", 
           RowBox[{"\"\<bounds_py\>\"", " ", "\[Rule]", " ", 
            RowBox[{"ToExpression", "[", 
             RowBox[{"StringReplace", "[", 
              RowBox[{
               RowBox[{"#", "[", "\"\<bounds_py\>\"", "]"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\"\<(\>\"", " ", "\[Rule]", " ", "\"\<{\>\""}], ",",
                  " ", 
                 RowBox[{"\"\<)\>\"", " ", "\[Rule]", " ", "\"\<}\>\""}]}], 
                "}"}]}], "]"}], "]"}]}], ",", " ", 
           RowBox[{"\"\<bounds_pz\>\"", " ", "\[Rule]", " ", 
            RowBox[{"ToExpression", "[", 
             RowBox[{"StringReplace", "[", 
              RowBox[{
               RowBox[{"#", "[", "\"\<bounds_pz\>\"", "]"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\"\<(\>\"", " ", "\[Rule]", " ", "\"\<{\>\""}], ",",
                  " ", 
                 RowBox[{"\"\<)\>\"", " ", "\[Rule]", " ", "\"\<}\>\""}]}], 
                "}"}]}], "]"}], "]"}]}], ",", " ", 
           RowBox[{"\"\<bounds_sx\>\"", " ", "\[Rule]", " ", 
            RowBox[{"ToExpression", "[", 
             RowBox[{"StringReplace", "[", 
              RowBox[{
               RowBox[{"#", "[", "\"\<bounds_sx\>\"", "]"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\"\<(\>\"", " ", "\[Rule]", " ", "\"\<{\>\""}], ",",
                  " ", 
                 RowBox[{"\"\<)\>\"", " ", "\[Rule]", " ", "\"\<}\>\""}]}], 
                "}"}]}], "]"}], "]"}]}], ",", " ", 
           RowBox[{"\"\<bounds_sy\>\"", " ", "\[Rule]", " ", 
            RowBox[{"ToExpression", "[", 
             RowBox[{"StringReplace", "[", 
              RowBox[{
               RowBox[{"#", "[", "\"\<bounds_sy\>\"", "]"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\"\<(\>\"", " ", "\[Rule]", " ", "\"\<{\>\""}], ",",
                  " ", 
                 RowBox[{"\"\<)\>\"", " ", "\[Rule]", " ", "\"\<}\>\""}]}], 
                "}"}]}], "]"}], "]"}]}], ",", " ", 
           RowBox[{"\"\<bounds_sz\>\"", " ", "\[Rule]", " ", 
            RowBox[{"ToExpression", "[", 
             RowBox[{"StringReplace", "[", 
              RowBox[{
               RowBox[{"#", "[", "\"\<bounds_sz\>\"", "]"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\"\<(\>\"", " ", "\[Rule]", " ", "\"\<{\>\""}], ",",
                  " ", 
                 RowBox[{"\"\<)\>\"", " ", "\[Rule]", " ", "\"\<}\>\""}]}], 
                "}"}]}], "]"}], "]"}]}]}], " ", "|>"}]}], " ", "&"}]}], 
      "]"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.8508263256368217`*^9, 3.850826327388266*^9}, {
  3.850826393147484*^9, 3.8508264315612736`*^9}, {3.850826493464094*^9, 
  3.850826516244507*^9}, {3.850826603842187*^9, 3.850826605473226*^9}, {
  3.8508266605510178`*^9, 3.8508267877397757`*^9}, {3.8508279035462275`*^9, 
  3.8508279284330645`*^9}},
 CellLabel->
  "In[116]:=",ExpressionUUID->"fd4d50bf-f23f-4148-9e56-ba53a1bc4a03"],

Cell[BoxData[
 RowBox[{
  RowBox[{"goodData", " ", "=", " ", 
   RowBox[{"Import", "[", 
    RowBox[{
    "\"\<z-band-middle-all-dots-narrowsquare-diagnosis1-good.csv\>\"", ",", 
     "\"\<Dataset\>\"", ",", " ", 
     RowBox[{"HeaderLines", " ", "\[Rule]", " ", "1"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.8508278846811714`*^9, 3.8508278905888233`*^9}},
 CellLabel->
  "In[115]:=",ExpressionUUID->"fafb3592-acf6-4c30-b778-95cee2b80492"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"badData", " ", "=", " ", 
  RowBox[{"Import", "[", 
   RowBox[{
   "\"\<z-band-middle-all-dots-narrowsquare-diagnosis1-bad.csv\>\"", ",", 
    "\"\<Dataset\>\"", ",", " ", 
    RowBox[{"HeaderLines", " ", "\[Rule]", " ", "1"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.850824183909835*^9, 3.850824245786784*^9}},
 CellLabel->"In[3]:=",ExpressionUUID->"399d6d03-9281-42ab-ab9a-0a36ee548ab7"],

Cell[BoxData[
 TagBox[
  TemplateBox[{
    TagBox[
     DynamicModuleBox[{
      TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
       Association[
        "InitialData" -> 
         TypeSystem`CacheKey[
          6634440301000527310508061624080070618932089758798603944104], 
         "InitialShape" -> TypeSystem`PackageScope`HeaderShape[
           
           Association[{All, "model"} -> 1, {All, "index_px"} -> 
            1, {All, "index_py"} -> 1, {All, "index_pz"} -> 
            1, {All, "index_sx"} -> 1, {All, "index_sy"} -> 
            1, {All, "index_sz"} -> 1, {All, "bounds_px"} -> 
            1, {All, "bounds_py"} -> 1, {All, "bounds_pz"} -> 
            1, {All, "bounds_sx"} -> 1, {All, "bounds_sy"} -> 
            1, {All, "bounds_sz"} -> 1, {All, "actual_dipole_moment"} -> 
            1, {All, "actual_dipole_position"} -> 
            1, {All, "actual_dipole_freq"} -> 1, {All, "success"} -> 
            1, {All, "found_dipole_moment"} -> 
            1, {All, "found_dipole_position"} -> 
            1, {All, "found_dipole_frequency"} -> 1], 
           TypeSystem`PackageScope`Limited[
            TypeSystem`PackageScope`ColumnShape[
             TypeSystem`PackageScope`Limited[
              TypeSystem`PackageScope`RowShape[
               Association[
               "model" -> 
                TypeSystem`PackageScope`AtomShape[57.60000000000001], 
                "index_px" -> TypeSystem`PackageScope`AtomShape[34], 
                "index_py" -> TypeSystem`PackageScope`AtomShape[34], 
                "index_pz" -> TypeSystem`PackageScope`AtomShape[34], 
                "index_sx" -> TypeSystem`PackageScope`AtomShape[34], 
                "index_sy" -> TypeSystem`PackageScope`AtomShape[34], 
                "index_sz" -> TypeSystem`PackageScope`AtomShape[34], 
                "bounds_px" -> 
                TypeSystem`PackageScope`AtomShape[384.00000000000006`], 
                "bounds_py" -> 
                TypeSystem`PackageScope`AtomShape[364.80000000000007`], 
                "bounds_pz" -> 
                TypeSystem`PackageScope`AtomShape[374.40000000000003`], 
                "bounds_sx" -> 
                TypeSystem`PackageScope`AtomShape[124.80000000000001`], 
                "bounds_sy" -> 
                TypeSystem`PackageScope`AtomShape[124.80000000000001`], 
                "bounds_sz" -> 
                TypeSystem`PackageScope`AtomShape[96.00000000000001], 
                "actual_dipole_moment" -> 
                TypeSystem`PackageScope`AtomShape[480.00000000000006`], 
                "actual_dipole_position" -> 
                TypeSystem`PackageScope`AtomShape[480.00000000000006`], 
                "actual_dipole_freq" -> TypeSystem`PackageScope`AtomShape[34],
                 "success" -> 
                TypeSystem`PackageScope`AtomShape[48.00000000000001], 
                "found_dipole_moment" -> 
                TypeSystem`PackageScope`AtomShape[28.800000000000004`], 
                "found_dipole_position" -> 
                TypeSystem`PackageScope`AtomShape[28.800000000000004`], 
                "found_dipole_frequency" -> 
                TypeSystem`PackageScope`UnknownShape[False]]], 
              DirectedInfinity[1], 10, {All}]], 20, 
            DirectedInfinity[1], {}]], "InitialType" -> TypeSystem`Vector[
           
           TypeSystem`Struct[{
            "model", "index_px", "index_py", "index_pz", "index_sx", 
             "index_sy", "index_sz", "bounds_px", "bounds_py", "bounds_pz", 
             "bounds_sx", "bounds_sy", "bounds_sz", "actual_dipole_moment", 
             "actual_dipole_position", "actual_dipole_freq", "success", 
             "found_dipole_moment", "found_dipole_position", 
             "found_dipole_frequency"}, {
             TypeSystem`Atom[String], 
             TypeSystem`Atom[Integer], 
             TypeSystem`Atom[Integer], 
             TypeSystem`Atom[Integer], 
             TypeSystem`Atom[Integer], 
             TypeSystem`Atom[Integer], 
             TypeSystem`Atom[Integer], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[Integer], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], TypeSystem`AnyType}], 40500], "Meta" -> 
         Association["ID" -> 185078983998681], "RowTarget" -> 20, 
         "ColumnTarget" -> 10, "Shape" -> TypeSystem`PackageScope`HeaderShape[
           
           Association[{All, "model"} -> 1, {All, "index_px"} -> 
            1, {All, "index_py"} -> 1, {All, "index_pz"} -> 
            1, {All, "index_sx"} -> 1, {All, "index_sy"} -> 
            1, {All, "index_sz"} -> 1, {All, "bounds_px"} -> 
            1, {All, "bounds_py"} -> 1, {All, "bounds_pz"} -> 
            1, {All, "bounds_sx"} -> 1, {All, "bounds_sy"} -> 
            1, {All, "bounds_sz"} -> 1, {All, "actual_dipole_moment"} -> 
            1, {All, "actual_dipole_position"} -> 
            1, {All, "actual_dipole_freq"} -> 1, {All, "success"} -> 
            1, {All, "found_dipole_moment"} -> 
            1, {All, "found_dipole_position"} -> 
            1, {All, "found_dipole_frequency"} -> 1], 
           TypeSystem`PackageScope`Limited[
            TypeSystem`PackageScope`ColumnShape[
             TypeSystem`PackageScope`Limited[
              TypeSystem`PackageScope`RowShape[
               Association[
               "model" -> 
                TypeSystem`PackageScope`AtomShape[57.60000000000001], 
                "index_px" -> TypeSystem`PackageScope`AtomShape[34], 
                "index_py" -> TypeSystem`PackageScope`AtomShape[34], 
                "index_pz" -> TypeSystem`PackageScope`AtomShape[34], 
                "index_sx" -> TypeSystem`PackageScope`AtomShape[34], 
                "index_sy" -> TypeSystem`PackageScope`AtomShape[34], 
                "index_sz" -> TypeSystem`PackageScope`AtomShape[34], 
                "bounds_px" -> 
                TypeSystem`PackageScope`AtomShape[384.00000000000006`], 
                "bounds_py" -> 
                TypeSystem`PackageScope`AtomShape[364.80000000000007`], 
                "bounds_pz" -> 
                TypeSystem`PackageScope`AtomShape[374.40000000000003`], 
                "bounds_sx" -> 
                TypeSystem`PackageScope`AtomShape[124.80000000000001`], 
                "bounds_sy" -> 
                TypeSystem`PackageScope`AtomShape[124.80000000000001`], 
                "bounds_sz" -> 
                TypeSystem`PackageScope`AtomShape[96.00000000000001], 
                "actual_dipole_moment" -> 
                TypeSystem`PackageScope`AtomShape[480.00000000000006`], 
                "actual_dipole_position" -> 
                TypeSystem`PackageScope`AtomShape[480.00000000000006`], 
                "actual_dipole_freq" -> TypeSystem`PackageScope`AtomShape[34],
                 "success" -> 
                TypeSystem`PackageScope`AtomShape[48.00000000000001], 
                "found_dipole_moment" -> 
                TypeSystem`PackageScope`AtomShape[28.800000000000004`], 
                "found_dipole_position" -> 
                TypeSystem`PackageScope`AtomShape[28.800000000000004`], 
                "found_dipole_frequency" -> 
                TypeSystem`PackageScope`UnknownShape[False]]], 
              DirectedInfinity[1], 10, {All}]], 20, 
            DirectedInfinity[1], {}]], "Type" -> TypeSystem`Vector[
           
           TypeSystem`Struct[{
            "model", "index_px", "index_py", "index_pz", "index_sx", 
             "index_sy", "index_sz", "bounds_px", "bounds_py", "bounds_pz", 
             "bounds_sx", "bounds_sy", "bounds_sz", "actual_dipole_moment", 
             "actual_dipole_position", "actual_dipole_freq", "success", 
             "found_dipole_moment", "found_dipole_position", 
             "found_dipole_frequency"}, {
             TypeSystem`Atom[String], 
             TypeSystem`Atom[Integer], 
             TypeSystem`Atom[Integer], 
             TypeSystem`Atom[Integer], 
             TypeSystem`Atom[Integer], 
             TypeSystem`Atom[Integer], 
             TypeSystem`Atom[Integer], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[Integer], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], 
             TypeSystem`Atom[String], TypeSystem`AnyType}], 40500], 
         "Path" -> {}, "BaseIndices" -> {}, "DisplayedRowCount" -> 20, 
         "DisplayedColumnCount" -> 10, "DataRowCount" -> 40500, 
         "DataColumnCount" -> 20, "SortPaths" -> {}, "SortDirections" -> {}, 
         "HiddenItemsMap" -> Null, "UpdateType" -> 1], 
       TypeSystem`NestedGrid`PackagePrivate`$outputID$$, 
       TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
       TypeSystem`NestedGrid`PackagePrivate`$vPos$$ = 1, 
       TypeSystem`NestedGrid`PackagePrivate`$hPos$$ = 1, 
       TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
       DynamicModule[{
         TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
            Style[
             Grid[{{
                Item[
                 Pane[
                  Annotation[
                   EventHandler[
                    MouseAppearance[
                    Mouseover["model", 
                    Style[
                    "model", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]]][{
                    All, "model"}, 1]], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{
                    All, "model"}, "ColumnHeader", True], "Mouse"], 
                  ImageSize -> {{1, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], Background -> 
                 GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                Item[
                 Pane[
                  Annotation[
                   EventHandler[
                    MouseAppearance[
                    Mouseover["index_px", 
                    Style[
                    "index_px", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]]][{
                    All, "index_px"}, 1]], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{
                    All, "index_px"}, "ColumnHeader", True], "Mouse"], 
                  ImageSize -> {{1, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], Background -> 
                 GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                Item[
                 Pane[
                  Annotation[
                   EventHandler[
                    MouseAppearance[
                    Mouseover["index_py", 
                    Style[
                    "index_py", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]]][{
                    All, "index_py"}, 1]], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{
                    All, "index_py"}, "ColumnHeader", True], "Mouse"], 
                  ImageSize -> {{1, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], Background -> 
                 GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                Item[
                 Pane[
                  Annotation[
                   EventHandler[
                    MouseAppearance[
                    Mouseover["index_pz", 
                    Style[
                    "index_pz", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]]][{
                    All, "index_pz"}, 1]], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{
                    All, "index_pz"}, "ColumnHeader", True], "Mouse"], 
                  ImageSize -> {{1, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], Background -> 
                 GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                Item[
                 Pane[
                  Annotation[
                   EventHandler[
                    MouseAppearance[
                    Mouseover["index_sx", 
                    Style[
                    "index_sx", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]]][{
                    All, "index_sx"}, 1]], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{
                    All, "index_sx"}, "ColumnHeader", True], "Mouse"], 
                  ImageSize -> {{1, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], Background -> 
                 GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                Item[
                 Pane[
                  Annotation[
                   EventHandler[
                    MouseAppearance[
                    Mouseover["index_sy", 
                    Style[
                    "index_sy", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]]][{
                    All, "index_sy"}, 1]], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{
                    All, "index_sy"}, "ColumnHeader", True], "Mouse"], 
                  ImageSize -> {{1, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], Background -> 
                 GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                Item[
                 Pane[
                  Annotation[
                   EventHandler[
                    MouseAppearance[
                    Mouseover["index_sz", 
                    Style[
                    "index_sz", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]]][{
                    All, "index_sz"}, 1]], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{
                    All, "index_sz"}, "ColumnHeader", True], "Mouse"], 
                  ImageSize -> {{1, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], Background -> 
                 GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                Item[
                 Pane[
                  Annotation[
                   EventHandler[
                    MouseAppearance[
                    Mouseover["bounds_px", 
                    Style[
                    "bounds_px", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]]][{
                    All, "bounds_px"}, 1]], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{
                    All, "bounds_px"}, "ColumnHeader", True], "Mouse"], 
                  ImageSize -> {{1, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], Background -> 
                 GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                Item[
                 Pane[
                  Annotation[
                   EventHandler[
                    MouseAppearance[
                    Mouseover["bounds_py", 
                    Style[
                    "bounds_py", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]]][{
                    All, "bounds_py"}, 1]], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{
                    All, "bounds_py"}, "ColumnHeader", True], "Mouse"], 
                  ImageSize -> {{1, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], Background -> 
                 GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                Item[
                 Pane[
                  Annotation[
                   EventHandler[
                    MouseAppearance[
                    Mouseover["bounds_pz", 
                    Style[
                    "bounds_pz", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]]][{
                    All, "bounds_pz"}, 1]], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{
                    All, "bounds_pz"}, "ColumnHeader", True], "Mouse"], 
                  ImageSize -> {{1, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], Background -> 
                 GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{1, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{1, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{1, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{1, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{1, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{1, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{1, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{1, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{1, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{1, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{2, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{2, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{2, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{2, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{2, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{2, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["1"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{2, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{2, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{2, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{2, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{3, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{3, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{3, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{3, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{3, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{3, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["2"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{3, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{3, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{3, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{3, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{4, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{4, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{4, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{4, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{4, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{4, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["3"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{4, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{4, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{4, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{4, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{5, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{5, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{5, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{5, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{5, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{5, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["4"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{5, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{5, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{5, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{5, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{6, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{6, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{6, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{6, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{6, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["1"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{6, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{6, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{6, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{6, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{6, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{7, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{7, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{7, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{7, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{7, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["1"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{7, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["1"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{7, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{7, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{7, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{7, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{8, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{8, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{8, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{8, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{8, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["1"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{8, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["2"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{8, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{8, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{8, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{8, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{9, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{9, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{9, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{9, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{9, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["1"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{9, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["3"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{9, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{9, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{9, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{9, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{10, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{10, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{10, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{10, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{10, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["1"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{10, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["4"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{10, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{10, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{10, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{10, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{11, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{11, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{11, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{11, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{11, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["2"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{11, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{11, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{11, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{11, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{11, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{12, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{12, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{12, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{12, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{12, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["2"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{12, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["1"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{12, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{12, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{12, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{12, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{13, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{13, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{13, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{13, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{13, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["2"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{13, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["2"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{13, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{13, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{13, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{13, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{14, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{14, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{14, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{14, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{14, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["2"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{14, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["3"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{14, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{14, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{14, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{14, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{15, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{15, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{15, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{15, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{15, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["2"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{15, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["4"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{15, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{15, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{15, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{15, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{16, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{16, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{16, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{16, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{16, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["3"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{16, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{16, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{16, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{16, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{16, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{17, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{17, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{17, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{17, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{17, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["3"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{17, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["1"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{17, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{17, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{17, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{17, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{18, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{18, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{18, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{18, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{18, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["3"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{18, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["2"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{18, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{18, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{18, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{18, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{19, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{19, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{19, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{19, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{19, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["3"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{19, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["3"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{19, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{19, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{19, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{19, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Pane[
                  Annotation["low", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{20, 
                    Key["model"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{57.60000000000001, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{20, 
                    Key["index_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{20, 
                    Key["index_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{20, 
                    Key["index_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["0"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{20, 
                    Key["index_sx"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["3"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{20, 
                    Key["index_sy"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation[
                   RawBoxes["4"], 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{20, 
                    Key["index_sz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{34, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{20, 
                    Key["bounds_px"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{384.00000000000006`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -6.666666666666666)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{20, 
                    Key["bounds_py"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{364.80000000000007`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}], 
                Item[
                 Pane[
                  Annotation["(-10.0, -3.333333333333333)", 
                   TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][{20, 
                    Key["bounds_pz"]}, "Item", False], "Mouse"], 
                  ImageSize -> {{374.40000000000003`, Full}, Automatic}, 
                  ImageMargins -> {{5, 3}, {4, 5}}], 
                 ItemSize -> {Full, Automatic}]}, {
                Item[
                 Deploy[
                  Pane[
                   Row[{
                    Spacer[2], 
                    Style[
                    Row[{
                    Button[
                    MouseAppearance[
                    Mouseover[
                    Graphics[{{
                    EdgeForm[None], 
                    FaceForm[None], 
                    Rectangle[{0, 0}, {18, 18}, RoundingRadius -> 2]}, 
                    Rotate[
                    Translate[{
                    CapForm[Round], 
                    RGBColor[
                    0.5372549019607843, 0.5372549019607843, 
                    0.5372549019607843], 
                    Line[{{0, 0}, {4, 5}, {8, 0}}], 
                    Line[{{0, 5}, {8, 5}}]}, {5, 6.5}], 0, {9, 9}]}, 
                    ImageSize -> (1 -> 1), ImagePadding -> {{0, 1}, {1, 0}}, 
                    BaselinePosition -> Scaled[0.35]], 
                    Graphics[{{
                    EdgeForm[
                    RGBColor[
                    0.27450980392156865`, 0.5411764705882353, 
                    0.796078431372549]], 
                    FaceForm[None], 
                    Rectangle[{0, 0}, {18, 18}, RoundingRadius -> 2]}, 
                    Rotate[
                    Translate[{
                    CapForm[Round], 
                    RGBColor[
                    0.27450980392156865`, 0.5411764705882353, 
                    0.796078431372549], 
                    Line[{{0, 0}, {4, 5}, {8, 0}}], 
                    Line[{{0, 5}, {8, 5}}]}, {5, 6.5}], 0, {9, 9}]}, 
                    ImageSize -> (1 -> 1), ImagePadding -> {{0, 1}, {1, 0}}, 
                    BaselinePosition -> Scaled[0.35]]], "LinkHand"], 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$ = 
                    Clip[TypeSystem`NestedGrid`PackagePrivate`$vPos$$ + (-20) 
                    If[True, 40500, 1], {1, 40500 - -20 + 1}]; 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]], True][
                    TypeSystem`NestedGrid`PackagePrivate`$path$$], Appearance -> 
                    None], 
                    Button[
                    MouseAppearance[
                    Mouseover[
                    Graphics[{{
                    EdgeForm[None], 
                    FaceForm[None], 
                    Rectangle[{0, 0}, {18, 18}, RoundingRadius -> 2]}, 
                    Rotate[
                    Translate[{
                    CapForm[Round], 
                    RGBColor[
                    0.5372549019607843, 0.5372549019607843, 
                    0.5372549019607843], 
                    Line[{{0, 0}, {4, 5}, {8, 0}}]}, {5, 6.5}], 0, {9, 9}]}, 
                    ImageSize -> (1 -> 1), ImagePadding -> {{0, 1}, {1, 0}}, 
                    BaselinePosition -> Scaled[0.35]], 
                    Graphics[{{
                    EdgeForm[
                    RGBColor[
                    0.27450980392156865`, 0.5411764705882353, 
                    0.796078431372549]], 
                    FaceForm[None], 
                    Rectangle[{0, 0}, {18, 18}, RoundingRadius -> 2]}, 
                    Rotate[
                    Translate[{
                    CapForm[Round], 
                    RGBColor[0.27450980392156865`, 0.5411764705882353, 
                    0.796078431372549], 
                    Line[{{0, 0}, {4, 5}, {8, 0}}]}, {5, 6.5}], 0, {9, 9}]}, 
                    ImageSize -> (1 -> 1), ImagePadding -> {{0, 1}, {1, 0}}, 
                    BaselinePosition -> Scaled[0.35]]], "LinkHand"], 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$ = 
                    Clip[TypeSystem`NestedGrid`PackagePrivate`$vPos$$ + (-20) 
                    If[False, 40500, 1], {1, 40500 - -20 + 1}]; 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]], True][
                    TypeSystem`NestedGrid`PackagePrivate`$path$$], Appearance -> 
                    None], " ", 
                    Style[
                    Mouseover[
                    Row[{"rows ", 1, "\[Dash]", 20, " of ", 
                    Style[
                    40500, FontColor -> GrayLevel[0], FontWeight -> 
                    "Medium"]}, 
                    BaseStyle -> {
                    FontSize -> 8., FontColor -> 
                    RGBColor[0.5098039215686274, 0.5098039215686274, 
                    0.5098039215686274]}], 
                    Row[{"rows ", 1, "\[Dash]", 20, " of ", 
                    Style[
                    40500, FontColor -> GrayLevel[0], FontWeight -> 
                    "Medium"]}, 
                    BaseStyle -> {
                    FontSize -> 8., FontColor -> 
                    RGBColor[0.5098039215686274, 0.5098039215686274, 
                    0.5098039215686274]}]], ContextMenu -> {
                    MenuItem["Hide", 
                    KernelExecute[
                    
                    TypeSystem`NestedGrid`PackagePrivate`adjustLimits[{
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]}, 
                    "Rows", 1, {}]], MenuEvaluator -> Automatic], 
                    MenuItem["Show up to 10 Rows", 
                    KernelExecute[
                    
                    TypeSystem`NestedGrid`PackagePrivate`adjustLimits[{
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]}, 
                    "Rows", 10, {}]], MenuEvaluator -> Automatic], 
                    MenuItem["Show up to 30 Rows", 
                    KernelExecute[
                    
                    TypeSystem`NestedGrid`PackagePrivate`adjustLimits[{
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]}, 
                    "Rows", 30, {}]], MenuEvaluator -> Automatic], 
                    MenuItem["Show up to 100 Rows", 
                    KernelExecute[
                    
                    TypeSystem`NestedGrid`PackagePrivate`adjustLimits[{
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]}, 
                    "Rows", 100, {}]], MenuEvaluator -> Automatic], 
                    MenuItem["Show All", 
                    KernelExecute[
                    
                    TypeSystem`NestedGrid`PackagePrivate`adjustLimits[{
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]}, 
                    "Rows", 100000000, {}]], MenuEvaluator -> Automatic]}], 
                    " ", 
                    Button[
                    MouseAppearance[
                    Mouseover[
                    Graphics[{{
                    EdgeForm[None], 
                    FaceForm[None], 
                    Rectangle[{0, 0}, {18, 18}, RoundingRadius -> 2]}, 
                    Rotate[
                    Translate[{
                    CapForm[Round], 
                    RGBColor[
                    0.5372549019607843, 0.5372549019607843, 
                    0.5372549019607843], 
                    Line[{{0, 0}, {4, 5}, {8, 0}}]}, {5, 6.5}], 180 Degree, {
                    9, 9}]}, ImageSize -> (1 -> 1), 
                    ImagePadding -> {{0, 1}, {1, 0}}, BaselinePosition -> 
                    Scaled[0.35]], 
                    Graphics[{{
                    EdgeForm[
                    RGBColor[
                    0.27450980392156865`, 0.5411764705882353, 
                    0.796078431372549]], 
                    FaceForm[None], 
                    Rectangle[{0, 0}, {18, 18}, RoundingRadius -> 2]}, 
                    Rotate[
                    Translate[{
                    CapForm[Round], 
                    RGBColor[
                    0.27450980392156865`, 0.5411764705882353, 
                    0.796078431372549], 
                    Line[{{0, 0}, {4, 5}, {8, 0}}]}, {5, 6.5}], 180 Degree, {
                    9, 9}]}, ImageSize -> (1 -> 1), 
                    ImagePadding -> {{0, 1}, {1, 0}}, BaselinePosition -> 
                    Scaled[0.35]]], "LinkHand"], 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$ = 
                    Clip[TypeSystem`NestedGrid`PackagePrivate`$vPos$$ + 
                    20 If[False, 40500, 1], {1, 40500 - 20 + 1}]; 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]], True][
                    TypeSystem`NestedGrid`PackagePrivate`$path$$], Appearance -> 
                    None], 
                    Button[
                    MouseAppearance[
                    Mouseover[
                    Graphics[{{
                    EdgeForm[None], 
                    FaceForm[None], 
                    Rectangle[{0, 0}, {18, 18}, RoundingRadius -> 2]}, 
                    Rotate[
                    Translate[{
                    CapForm[Round], 
                    RGBColor[
                    0.5372549019607843, 0.5372549019607843, 
                    0.5372549019607843], 
                    Line[{{0, 0}, {4, 5}, {8, 0}}], 
                    Line[{{0, 5}, {8, 5}}]}, {5, 6.5}], 180 Degree, {9, 9}]}, 
                    ImageSize -> (1 -> 1), ImagePadding -> {{0, 1}, {1, 0}}, 
                    BaselinePosition -> Scaled[0.35]], 
                    Graphics[{{
                    EdgeForm[
                    RGBColor[
                    0.27450980392156865`, 0.5411764705882353, 
                    0.796078431372549]], 
                    FaceForm[None], 
                    Rectangle[{0, 0}, {18, 18}, RoundingRadius -> 2]}, 
                    Rotate[
                    Translate[{
                    CapForm[Round], 
                    RGBColor[
                    0.27450980392156865`, 0.5411764705882353, 
                    0.796078431372549], 
                    Line[{{0, 0}, {4, 5}, {8, 0}}], 
                    Line[{{0, 5}, {8, 5}}]}, {5, 6.5}], 180 Degree, {9, 9}]}, 
                    ImageSize -> (1 -> 1), ImagePadding -> {{0, 1}, {1, 0}}, 
                    BaselinePosition -> Scaled[0.35]]], "LinkHand"], 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$ = 
                    Clip[TypeSystem`NestedGrid`PackagePrivate`$vPos$$ + 
                    20 If[True, 40500, 1], {1, 40500 - 20 + 1}]; 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]], True][
                    TypeSystem`NestedGrid`PackagePrivate`$path$$], Appearance -> 
                    None]}], ContextMenu -> {}], 
                    Graphics[{
                    RGBColor[
                    0.8196078431372549, 0.8196078431372549, 
                    0.8196078431372549], 
                    Line[{{0, 0}, {0, 19}}]}, ImageSize -> (1 -> 1), 
                    ImagePadding -> {{0, 0}, {0, 0}}, BaselinePosition -> 
                    Scaled[0.35]], 
                    Spacer[2], 
                    Style[
                    Row[{
                    Button[
                    MouseAppearance[
                    Mouseover[
                    Graphics[{{
                    EdgeForm[None], 
                    FaceForm[None], 
                    Rectangle[{2, 0}, {16, 18}, RoundingRadius -> 2]}, 
                    Rotate[
                    Translate[{
                    CapForm[Round], 
                    RGBColor[
                    0.5372549019607843, 0.5372549019607843, 
                    0.5372549019607843], 
                    Line[{{0, 0}, {4, 5}, {8, 0}}], 
                    Line[{{0, 5}, {8, 5}}]}, {5, 6.5}], 90 Degree, {9, 9}]}, 
                    ImageSize -> (1 -> 1), ImagePadding -> {{0, 1}, {1, 0}}, 
                    BaselinePosition -> Scaled[0.35]], 
                    Graphics[{{
                    EdgeForm[
                    RGBColor[
                    0.27450980392156865`, 0.5411764705882353, 
                    0.796078431372549]], 
                    FaceForm[None], 
                    Rectangle[{2, 0}, {16, 18}, RoundingRadius -> 2]}, 
                    Rotate[
                    Translate[{
                    CapForm[Round], 
                    RGBColor[
                    0.27450980392156865`, 0.5411764705882353, 
                    0.796078431372549], 
                    Line[{{0, 0}, {4, 5}, {8, 0}}], 
                    Line[{{0, 5}, {8, 5}}]}, {5, 6.5}], 90 Degree, {9, 9}]}, 
                    ImageSize -> (1 -> 1), ImagePadding -> {{0, 1}, {1, 0}}, 
                    BaselinePosition -> Scaled[0.35]]], "LinkHand"], 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$ = 
                    Clip[TypeSystem`NestedGrid`PackagePrivate`$hPos$$ + (-10) 
                    If[True, 20, 1], {1, 20 - -10 + 1}]; 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]], True][
                    TypeSystem`NestedGrid`PackagePrivate`$path$$], Appearance -> 
                    None], 
                    Button[
                    MouseAppearance[
                    Mouseover[
                    Graphics[{{
                    EdgeForm[None], 
                    FaceForm[None], 
                    Rectangle[{2, 0}, {16, 18}, RoundingRadius -> 2]}, 
                    Rotate[
                    Translate[{
                    CapForm[Round], 
                    RGBColor[
                    0.5372549019607843, 0.5372549019607843, 
                    0.5372549019607843], 
                    Line[{{0, 0}, {4, 5}, {8, 0}}]}, {5, 6.5}], 90 Degree, {9,
                     9}]}, ImageSize -> (1 -> 1), 
                    ImagePadding -> {{0, 1}, {1, 0}}, BaselinePosition -> 
                    Scaled[0.35]], 
                    Graphics[{{
                    EdgeForm[
                    RGBColor[
                    0.27450980392156865`, 0.5411764705882353, 
                    0.796078431372549]], 
                    FaceForm[None], 
                    Rectangle[{2, 0}, {16, 18}, RoundingRadius -> 2]}, 
                    Rotate[
                    Translate[{
                    CapForm[Round], 
                    RGBColor[
                    0.27450980392156865`, 0.5411764705882353, 
                    0.796078431372549], 
                    Line[{{0, 0}, {4, 5}, {8, 0}}]}, {5, 6.5}], 90 Degree, {9,
                     9}]}, ImageSize -> (1 -> 1), 
                    ImagePadding -> {{0, 1}, {1, 0}}, BaselinePosition -> 
                    Scaled[0.35]]], "LinkHand"], 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$ = 
                    Clip[TypeSystem`NestedGrid`PackagePrivate`$hPos$$ + (-10) 
                    If[False, 20, 1], {1, 20 - -10 + 1}]; 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]], True][
                    TypeSystem`NestedGrid`PackagePrivate`$path$$], Appearance -> 
                    None], " ", 
                    Style[
                    Mouseover[
                    Row[{"columns ", 1, "\[Dash]", 10, " of ", 
                    Style[
                    20, FontColor -> GrayLevel[0], FontWeight -> "Medium"]}, 
                    BaseStyle -> {
                    FontSize -> 8., FontColor -> 
                    RGBColor[0.5098039215686274, 0.5098039215686274, 
                    0.5098039215686274]}], 
                    Row[{"columns ", 1, "\[Dash]", 10, " of ", 
                    Style[
                    20, FontColor -> GrayLevel[0], FontWeight -> "Medium"]}, 
                    BaseStyle -> {
                    FontSize -> 8., FontColor -> 
                    RGBColor[0.5098039215686274, 0.5098039215686274, 
                    0.5098039215686274]}]], ContextMenu -> {
                    MenuItem["Hide", 
                    KernelExecute[
                    
                    TypeSystem`NestedGrid`PackagePrivate`adjustLimits[{
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]}, 
                    "Columns", 1, {}]], MenuEvaluator -> Automatic], 
                    MenuItem["Show up to 2 Columns", 
                    KernelExecute[
                    
                    TypeSystem`NestedGrid`PackagePrivate`adjustLimits[{
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]}, 
                    "Columns", 2, {}]], MenuEvaluator -> Automatic], 
                    MenuItem["Show up to 5 Columns", 
                    KernelExecute[
                    
                    TypeSystem`NestedGrid`PackagePrivate`adjustLimits[{
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]}, 
                    "Columns", 5, {}]], MenuEvaluator -> Automatic], 
                    MenuItem["Show up to 10 Columns", 
                    KernelExecute[
                    
                    TypeSystem`NestedGrid`PackagePrivate`adjustLimits[{
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]}, 
                    "Columns", 10, {}]], MenuEvaluator -> Automatic], 
                    MenuItem["Show All", 
                    KernelExecute[
                    
                    TypeSystem`NestedGrid`PackagePrivate`adjustLimits[{
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]}, 
                    "Columns", 100000000, {}]], MenuEvaluator -> Automatic]}],
                     " ", 
                    Button[
                    MouseAppearance[
                    Mouseover[
                    Graphics[{{
                    EdgeForm[None], 
                    FaceForm[None], 
                    Rectangle[{2, 0}, {16, 18}, RoundingRadius -> 2]}, 
                    Rotate[
                    Translate[{
                    CapForm[Round], 
                    RGBColor[
                    0.5372549019607843, 0.5372549019607843, 
                    0.5372549019607843], 
                    Line[{{0, 0}, {4, 5}, {8, 0}}]}, {5, 6.5}], (-90) Degree,
                     {9, 9}]}, ImageSize -> (1 -> 1), 
                    ImagePadding -> {{0, 1}, {1, 0}}, BaselinePosition -> 
                    Scaled[0.35]], 
                    Graphics[{{
                    EdgeForm[
                    RGBColor[
                    0.27450980392156865`, 0.5411764705882353, 
                    0.796078431372549]], 
                    FaceForm[None], 
                    Rectangle[{2, 0}, {16, 18}, RoundingRadius -> 2]}, 
                    Rotate[
                    Translate[{
                    CapForm[Round], 
                    RGBColor[
                    0.27450980392156865`, 0.5411764705882353, 
                    0.796078431372549], 
                    Line[{{0, 0}, {4, 5}, {8, 0}}]}, {5, 6.5}], (-90) 
                    Degree, {9, 9}]}, ImageSize -> (1 -> 1), 
                    ImagePadding -> {{0, 1}, {1, 0}}, BaselinePosition -> 
                    Scaled[0.35]]], "LinkHand"], 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$ = 
                    Clip[TypeSystem`NestedGrid`PackagePrivate`$hPos$$ + 
                    10 If[False, 20, 1], {1, 20 - 10 + 1}]; 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]], True][
                    TypeSystem`NestedGrid`PackagePrivate`$path$$], Appearance -> 
                    None], 
                    Button[
                    MouseAppearance[
                    Mouseover[
                    Graphics[{{
                    EdgeForm[None], 
                    FaceForm[None], 
                    Rectangle[{2, 0}, {16, 18}, RoundingRadius -> 2]}, 
                    Rotate[
                    Translate[{
                    CapForm[Round], 
                    RGBColor[
                    0.5372549019607843, 0.5372549019607843, 
                    0.5372549019607843], 
                    Line[{{0, 0}, {4, 5}, {8, 0}}], 
                    Line[{{0, 5}, {8, 5}}]}, {5, 6.5}], (-90) Degree, {9, 
                    9}]}, ImageSize -> (1 -> 1), 
                    ImagePadding -> {{0, 1}, {1, 0}}, BaselinePosition -> 
                    Scaled[0.35]], 
                    Graphics[{{
                    EdgeForm[
                    RGBColor[
                    0.27450980392156865`, 0.5411764705882353, 
                    0.796078431372549]], 
                    FaceForm[None], 
                    Rectangle[{2, 0}, {16, 18}, RoundingRadius -> 2]}, 
                    Rotate[
                    Translate[{
                    CapForm[Round], 
                    RGBColor[
                    0.27450980392156865`, 0.5411764705882353, 
                    0.796078431372549], 
                    Line[{{0, 0}, {4, 5}, {8, 0}}], 
                    Line[{{0, 5}, {8, 5}}]}, {5, 6.5}], (-90) Degree, {9, 
                    9}]}, ImageSize -> (1 -> 1), 
                    ImagePadding -> {{0, 1}, {1, 0}}, BaselinePosition -> 
                    Scaled[0.35]]], "LinkHand"], 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$ = 
                    Clip[TypeSystem`NestedGrid`PackagePrivate`$hPos$$ + 
                    10 If[True, 20, 1], {1, 20 - 10 + 1}]; 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]], True][
                    TypeSystem`NestedGrid`PackagePrivate`$path$$], Appearance -> 
                    None]}], ContextMenu -> {}], 
                    Graphics[{
                    RGBColor[
                    0.8196078431372549, 0.8196078431372549, 
                    0.8196078431372549], 
                    Line[{{0, 0}, {0, 19}}]}, ImageSize -> (1 -> 1), 
                    ImagePadding -> {{0, 0}, {0, 0}}, BaselinePosition -> 
                    Scaled[0.35]]}], ImageMargins -> {{0, -1}, {-1, 1}}]], 
                 Background -> 
                 RGBColor[
                  0.9764705882352941, 0.9764705882352941, 0.9764705882352941],
                  Alignment -> {Left, Top}], SpanFromLeft, SpanFromLeft, 
                SpanFromLeft, SpanFromLeft, SpanFromLeft, SpanFromLeft, 
                SpanFromLeft, SpanFromLeft, SpanFromLeft}}, 
              BaseStyle -> {
               ContextMenu -> 
                Dynamic[
                 TypeSystem`NestedGrid`PackagePrivate`$contextMenuTrigger; 
                  Which[TypeSystem`NestedGrid`PackagePrivate`$lastOutputID =!= 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$], {}, 
                    TypeSystem`NestedGrid`PackagePrivate`$contextMenuTrigger === 
                    TypeSystem`NestedGrid`PackagePrivate`$\
lastContextMenuTrigger, TypeSystem`NestedGrid`PackagePrivate`$lastContextMenu,
                     True, TypeSystem`NestedGrid`PackagePrivate`$\
lastContextMenuTrigger = 
                    TypeSystem`NestedGrid`PackagePrivate`$contextMenuTrigger; 
                    TypeSystem`NestedGrid`PackagePrivate`$lastContextMenu = 
                    Block[{TypeSystem`NestedGrid`PackagePrivate`$\
globalScrollPos = {TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$}}, 
                    
                    With[{TypeSystem`NestedGrid`PackagePrivate`lastPath$ = 
                    TypeSystem`NestedGrid`PackagePrivate`$lastPath, 
                    TypeSystem`NestedGrid`PackagePrivate`lastPathType$ = 
                    TypeSystem`NestedGrid`PackagePrivate`$lastPathType, 
                    TypeSystem`NestedGrid`PackagePrivate`isLeafHeader$ = 
                    TypeSystem`NestedGrid`PackagePrivate`$\
lastPathIsLeafHeader, TypeSystem`NestedGrid`PackagePrivate`headerHidden$ = And[
                    MatchQ[TypeSystem`NestedGrid`PackagePrivate`$lastPathType, 
                    Alternatives["RowHeader", "ColumnHeader"]], 
                    TypeSystem`NestedGrid`PackagePrivate`headerHiddenQ[
                    TypeSystem`NestedGrid`PackagePrivate`$lastPath, 
                    TypeSystem`NestedGrid`PackagePrivate`$state$$]], 
                    TypeSystem`NestedGrid`PackagePrivate`allHidden$ = 
                    TypeSystem`NestedGrid`PackagePrivate`allHiddenQ[
                    TypeSystem`NestedGrid`PackagePrivate`$lastPath, 
                    TypeSystem`NestedGrid`PackagePrivate`$state$$], 
                    TypeSystem`NestedGrid`PackagePrivate`anyHidden$ = 
                    TypeSystem`NestedGrid`PackagePrivate`anyHiddenQ[
                    TypeSystem`NestedGrid`PackagePrivate`$lastPath, 
                    TypeSystem`NestedGrid`PackagePrivate`$state$$], 
                    TypeSystem`NestedGrid`PackagePrivate`sortDirection$ = 
                    TypeSystem`NestedGrid`PackagePrivate`columnSortDirection[
                    TypeSystem`NestedGrid`PackagePrivate`$lastPath, 
                    TypeSystem`NestedGrid`PackagePrivate`$state$$[
                    "SortPaths"], 
                    TypeSystem`NestedGrid`PackagePrivate`$state$$[
                    "SortDirections"]], 
                    TypeSystem`NestedGrid`PackagePrivate`haveData$ = Not[
                    FailureQ[
                    TypeSystem`NestedGrid`PackagePrivate`datasetInitialData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$]]], 
                    TypeSystem`NestedGrid`PackagePrivate`isKeyDummy$ = Not[
                    FreeQ[
                    TypeSystem`NestedGrid`PackagePrivate`$lastPath, Keys]]}, 
                    Join[{
                    If[
                    Or[
                    Not[TypeSystem`NestedGrid`PackagePrivate`haveData$], 
                    Not[TypeSystem`NestedGrid`PackagePrivate`anyHidden$], 
                    TypeSystem`NestedGrid`PackagePrivate`isKeyDummy$], 
                    Nothing, 
                    MenuItem[
                    StringJoin["Show ", 
                    Which[
                    TypeSystem`NestedGrid`PackagePrivate`lastPathType$ == 
                    "Item", "", 
                    TypeSystem`NestedGrid`PackagePrivate`lastPathType$ == 
                    "RowHeader", "Row", 
                    TypeSystem`NestedGrid`PackagePrivate`lastPathType$ == 
                    "ColumnHeader", "Column", True, ""]], 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`updateHiddenItems[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]]][
                    TypeSystem`NestedGrid`PackagePrivate`lastPath$, 
                    "remove"]], MenuEvaluator -> Automatic]], 
                    If[
                    Or[
                    Not[TypeSystem`NestedGrid`PackagePrivate`haveData$], 
                    TypeSystem`NestedGrid`PackagePrivate`pathEmptyQ[
                    TypeSystem`NestedGrid`PackagePrivate`$lastPath, 
                    TypeSystem`NestedGrid`PackagePrivate`$state$$], 
                    TypeSystem`NestedGrid`PackagePrivate`isKeyDummy$, 
                    And[
                    TypeSystem`NestedGrid`PackagePrivate`allHidden$, 
                    TypeSystem`NestedGrid`PackagePrivate`headerHidden$]], 
                    Nothing, 
                    MenuItem[
                    StringJoin["Hide ", 
                    Which[
                    TypeSystem`NestedGrid`PackagePrivate`lastPathType$ == 
                    "Item", "", 
                    TypeSystem`NestedGrid`PackagePrivate`lastPathType$ == 
                    "RowHeader", "Row", 
                    TypeSystem`NestedGrid`PackagePrivate`lastPathType$ == 
                    "ColumnHeader", "Column", True, ""]], 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`updateHiddenItems[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]]][
                    TypeSystem`NestedGrid`PackagePrivate`lastPath$, "add"]], 
                    MenuEvaluator -> Automatic]], Delimiter}, 
                    If[
                    And[TypeSystem`NestedGrid`PackagePrivate`haveData$, 
                    MatchQ[TypeSystem`NestedGrid`PackagePrivate`lastPathType$, 
                    Alternatives["ColumnHeader", "KeyDummy"]], 
                    TypeSystem`NestedGrid`PackagePrivate`isLeafHeader$, 
                    Not[TypeSystem`NestedGrid`PackagePrivate`allHidden$]], {
                    If[
                    TypeSystem`NestedGrid`PackagePrivate`sortDirection$ =!= 
                    "Ascending", 
                    MenuItem["Sort", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`updateSort[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][
                    TypeSystem`NestedGrid`PackagePrivate`lastPath$, 
                    "Ascending"]], MenuEvaluator -> Automatic], Nothing], 
                    If[
                    TypeSystem`NestedGrid`PackagePrivate`sortDirection$ =!= 
                    "Descending", 
                    MenuItem["Reverse Sort", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`updateSort[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][
                    TypeSystem`NestedGrid`PackagePrivate`lastPath$, 
                    "Descending"]], MenuEvaluator -> Automatic], Nothing], 
                    If[
                    TypeSystem`NestedGrid`PackagePrivate`sortDirection$ =!= 
                    None, 
                    MenuItem["Unsort", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`updateSort[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    TypeSystem`NestedGrid`PackagePrivate`localHold[
                    TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][
                    TypeSystem`NestedGrid`PackagePrivate`lastPath$, None]], 
                    MenuEvaluator -> Automatic], Nothing], Delimiter}, {}], {
                    MenuItem["Copy Position to Clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy Data to Clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste Position in New Cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste Data in New Cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}]]]]], FontFamily -> 
                "Verdana", FontSize -> 12}, Spacings -> {0, 0}, Alignment -> 
              Left, Dividers -> All, FrameStyle -> 
              GrayLevel[0.7490196078431373], 
              BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
             LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
             False, ShowAutoStyles -> False]], 
          TypeSystem`NestedGrid`PackagePrivate`initialQ = True}, 
         Dynamic[
          TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
          TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
             Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
             
             Module[{TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
               TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
               TypeSystem`NestedGrid`PackagePrivate`datasetData[
                TypeSystem`NestedGrid`PackagePrivate`$state$$]}, 
              TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = If[
                 FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpData$], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                 TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                 TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                  TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                  TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                  TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
                  TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                  TypeSystem`NestedGrid`PackagePrivate`localHold[
                  TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][
                 TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                Not[
                 FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
           TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
           TypeSystem`NestedGrid`PackagePrivate`$vPos$$; 
           TypeSystem`NestedGrid`PackagePrivate`$hPos$$; If[
             FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
             TypeSystem`SparseGrid[
              TypeSystem`H["(data no longer present)"]], 
             If[GeneralUtilities`$DebugMode, 
              Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                TypeSystem`NestedGrid`PackagePrivate`formatState[
                TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                 TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                 TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
                 TypeSystem`NestedGrid`PackagePrivate`$hPos$$]}], 
              TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
            TypeSystem`NestedGrid`PackagePrivate`$hPos$$}], 
         DynamicModuleValues :> {}], 
       TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
         TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
          TypeSystem`PackageScope`SubViewPathbar[
          TypeSystem`NestedGrid`PackagePrivate`$path$$, 
           TypeSystem`NestedGrid`PackagePrivate`updateState[
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$path$$, 
            TypeSystem`NestedGrid`PackagePrivate`$vPos$$, 
            TypeSystem`NestedGrid`PackagePrivate`$hPos$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
            TypeSystem`NestedGrid`PackagePrivate`localHold[
            TypeSystem`NestedGrid`PackagePrivate`$outputID$$]]]], 
         TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}], 
       TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Style[
         Framed[
          Dynamic[
           Replace[
           TypeSystem`NestedGrid`PackagePrivate`mouseAnnotation$$, {
            TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
               TypeSystem`NestedGrid`PackagePrivate`localHold[
               TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][Null, 
               Blank[]] -> "", 
             TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
               TypeSystem`NestedGrid`PackagePrivate`localHold[
               TypeSystem`NestedGrid`PackagePrivate`$outputID$$]][
               Pattern[TypeSystem`NestedGrid`PackagePrivate`path$, 
                Blank[]], 
               Pattern[TypeSystem`NestedGrid`PackagePrivate`pathType$, 
                Blank[]], 
               Pattern[TypeSystem`NestedGrid`PackagePrivate`isLeafHeader$, 
                Blank[]]] :> (
              Increment[
               TypeSystem`NestedGrid`PackagePrivate`$contextMenuTrigger]; 
              TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
               TypeSystem`NestedGrid`PackagePrivate`path$; 
              TypeSystem`NestedGrid`PackagePrivate`$lastPathType = 
               TypeSystem`NestedGrid`PackagePrivate`pathType$; 
              TypeSystem`NestedGrid`PackagePrivate`$lastPathIsLeafHeader = 
               TypeSystem`NestedGrid`PackagePrivate`isLeafHeader$; 
              TypeSystem`NestedGrid`PackagePrivate`$lastOutputID = 
               TypeSystem`NestedGrid`PackagePrivate`localHold[
                TypeSystem`NestedGrid`PackagePrivate`$outputID$$]; 
              TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
               TypeSystem`NestedGrid`PackagePrivate`path$, 
                TypeSystem`NestedGrid`PackagePrivate`makePathElements]), Null :> 
             Spacer[10], Blank[] :> Spacer[10]}], 
           TrackedSymbols :> {
            TypeSystem`NestedGrid`PackagePrivate`mouseAnnotation$$}], 
          FrameStyle -> None, ImageMargins -> 0, FrameMargins -> 0, Alignment -> 
          Top, ImageSize -> {Automatic, 15}], FontSize -> 1], 
       TypeSystem`NestedGrid`PackagePrivate`mouseAnnotation$$ = Null}, 
      DynamicWrapperBox[
       DynamicBox[
        ToBoxes[
         Dataset`DatasetContent[
         2, "Path" -> Hold[TypeSystem`NestedGrid`PackagePrivate`$path$$], 
          "Grid" -> Hold[TypeSystem`NestedGrid`PackagePrivate`$grid$$], 
          "State" -> Hold[TypeSystem`NestedGrid`PackagePrivate`$state$$], 
          "VPos" -> Hold[TypeSystem`NestedGrid`PackagePrivate`$vPos$$], 
          "HPos" -> Hold[TypeSystem`NestedGrid`PackagePrivate`$hPos$$], 
          "TopBar" -> Hold[TypeSystem`NestedGrid`PackagePrivate`$topBar$$], 
          "BottomBar" -> 
          Hold[TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$], "OutputID" -> 
          Hold[
            TypeSystem`NestedGrid`PackagePrivate`localHold[
            TypeSystem`NestedGrid`PackagePrivate`$outputID$$]]], 
         StandardForm], ImageSizeCache -> {1627., {288., 294.}}, 
        TrackedSymbols :> {
         TypeSystem`NestedGrid`PackagePrivate`$state$$, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
       TypeSystem`NestedGrid`PackagePrivate`mouseAnnotation$$ = 
       MouseAnnotation[], ImageSizeCache -> {1627., {288., 294.}}], 
      BaseStyle -> {LineBreakWithin -> False}, DynamicModuleValues :> {}, 
      Initialization :> 
      Block[{$ContextPath = $ContextPath}, Needs["TypeSystem`"]; 
        Needs["Dataset`"]; 
        TypeSystem`NestedGrid`PackagePrivate`$outputID$$ = CreateUUID[]], 
      UnsavedVariables :> {TypeSystem`NestedGrid`PackagePrivate`$outputID$$}],
      Deploy, DefaultBaseStyle -> "Deploy"]},
   "CopyTag",
   DisplayFunction->(#& ),
   InterpretationFunction->("Dataset[<>]"& )],
  False,
  BoxID -> 6634440301000527310508061624080070618932089758798603944104,
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{3.850824215485259*^9, 3.8508242503784404`*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"be48509f-3a83-4125-a7a4-a68d3e7cd87d"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"badGroup", " ", "=", " ", 
   RowBox[{
    RowBox[{"badDataClean", "[", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", "\"\<success\>\"", "]"}], " ", "\[Equal]", " ", 
        "\"\<True\>\""}], " ", "&"}], "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{"GroupBy", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"#", "[", "\"\<bounds_sx\>\"", "]"}], ",", " ", 
         RowBox[{"#", "[", "\"\<bounds_sy\>\"", "]"}], ",", " ", 
         RowBox[{"#", "[", "\"\<bounds_sz\>\"", "]"}]}], "}"}], " ", "&"}], 
      "]"}], ",", " ", "Length"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"goodGroup", " ", "=", " ", 
   RowBox[{
    RowBox[{"goodDataClean", "[", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", "\"\<success\>\"", "]"}], " ", "\[Equal]", " ", 
        "\"\<True\>\""}], " ", "&"}], "]"}], "]"}], "[", 
    RowBox[{
     RowBox[{"GroupBy", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"#", "[", "\"\<bounds_sx\>\"", "]"}], ",", " ", 
         RowBox[{"#", "[", "\"\<bounds_sy\>\"", "]"}], ",", " ", 
         RowBox[{"#", "[", "\"\<bounds_sz\>\"", "]"}]}], "}"}], " ", "&"}], 
      "]"}], ",", " ", "Length"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.8508243735901375`*^9, 3.8508244319086657`*^9}, {
   3.850824473554988*^9, 3.8508245604772215`*^9}, {3.8508247802213717`*^9, 
   3.8508248091508493`*^9}, {3.8508248412773695`*^9, 
   3.8508248566273775`*^9}, {3.850824899288953*^9, 3.8508249069068766`*^9}, 
   3.8508249764064865`*^9, {3.850825064024293*^9, 3.850825066539592*^9}, {
   3.850825253343743*^9, 3.8508252896546907`*^9}, {3.8508254064830613`*^9, 
   3.850825411829862*^9}, {3.85082545610826*^9, 3.850825477167108*^9}, {
   3.8508256190472465`*^9, 3.850825726572425*^9}, {3.8508267986015887`*^9, 
   3.8508267991059046`*^9}, {3.8508278659333563`*^9, 
   3.8508278722013493`*^9}, {3.8508280746933365`*^9, 3.850828086608127*^9}},
 CellLabel->
  "In[126]:=",ExpressionUUID->"4d1565da-7ee5-4a2d-9d57-9887b55a1112"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dotsWide", " ", "=", " ", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
         RowBox[{"#", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", " ", "0"}], "}"}], "]"}], " ", 
      "&"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2"}], ",", " ", "2"}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"2", ",", " ", "2"}], "}"}], ",", " ", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"-", "2"}], ",", " ", 
         RowBox[{"-", "2"}]}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"2", ",", " ", 
         RowBox[{"-", "2"}]}], "}"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.8508308330466833`*^9, 3.8508308840658135`*^9}, {
  3.850830915668857*^9, 3.850830915697891*^9}},
 CellLabel->
  "In[211]:=",ExpressionUUID->"aa9a0a43-39c2-4bf4-84c5-eb7a7967aa21"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dotsOriginal", " ", "=", " ", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
         RowBox[{"#", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", " ", "0"}], "}"}], "]"}], " ", 
      "&"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", " ", "2"}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"2", ",", " ", "2"}], "}"}], ",", " ", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"1", ",", " ", "1"}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"2", ",", " ", "1"}], "}"}]}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.850831713538842*^9, 3.8508317295750065`*^9}},
 CellLabel->
  "In[213]:=",ExpressionUUID->"1a81109c-458d-44a7-8bcc-34fa83e04c71"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dots", " ", "=", " ", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Point", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], ",", " ", "0"}], "}"}], "]"}], " ", 
     "&"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", ".25"}], ",", " ", ".25"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{".25", ",", " ", ".25"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", ".25"}], ",", " ", 
        RowBox[{"-", ".25"}]}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{".25", ",", " ", 
        RowBox[{"-", ".25"}]}], "}"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.850830184087348*^9, 3.850830285155801*^9}},
 CellLabel->
  "In[167]:=",ExpressionUUID->"00fc9902-1f9b-4741-86cb-83786c3156e8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Point", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "0.25`"}], ",", "0.25`", ",", "0"}], "}"}], "]"}], ",", 
   RowBox[{"Point", "[", 
    RowBox[{"{", 
     RowBox[{"0.25`", ",", "0.25`", ",", "0"}], "}"}], "]"}], ",", 
   RowBox[{"Point", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "0.25`"}], ",", 
      RowBox[{"-", "0.25`"}], ",", "0"}], "}"}], "]"}], ",", 
   RowBox[{"Point", "[", 
    RowBox[{"{", 
     RowBox[{"0.25`", ",", 
      RowBox[{"-", "0.25`"}], ",", "0"}], "}"}], "]"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.8508302403217235`*^9, 3.8508302860059795`*^9}},
 CellLabel->
  "Out[167]=",ExpressionUUID->"31674224-2ec9-4f15-ba1b-1b9b5c9556eb"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"cuboidFromBounds", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x1_", ",", " ", "x2_"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"y1_", ",", " ", "y2_"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"z1_", ",", " ", "z2_"}], "}"}]}], "}"}], "]"}], " ", ":=", " ", 
  RowBox[{"Cuboid", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x1", ",", " ", "y1", ",", " ", "z1"}], "}"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"x2", ",", " ", "y2", ",", " ", "z2"}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.8508270012314577`*^9, 3.8508270755013294`*^9}},
 CellLabel->"In[78]:=",ExpressionUUID->"f44036f4-85a6-40c9-94c6-c6cef163a563"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{
   RowBox[{"{", " ", 
    RowBox[{
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{"Opacity", "[", "0.2", "]"}], ",", " ", "Red", ",", "  ", 
       RowBox[{"Cuboid", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "10"}], ",", " ", 
           RowBox[{"-", "10"}], ",", " ", "3.5"}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"10", ",", " ", "10", ",", " ", "4.5"}], "}"}]}], "]"}]}], 
      "}"}], ",", " ", 
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{"Opacity", "[", "0.1", "]"}], ",", " ", "Blue", ",", " ", 
       RowBox[{"FaceForm", "[", 
        RowBox[{"Green", ",", " ", 
         RowBox[{"Opacity", "[", "0", "]"}]}], "]"}], ",", " ", 
       RowBox[{"Cuboid", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "10"}], ",", " ", 
           RowBox[{"-", "10"}], ",", " ", "2.5"}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"10", ",", " ", "10", ",", " ", "3.5"}], "}"}]}], "]"}]}], 
      "}"}], ",", " ", 
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{"Opacity", "[", "0.1", "]"}], ",", " ", "Blue", ",", " ", 
       RowBox[{"FaceForm", "[", 
        RowBox[{"White", ",", " ", 
         RowBox[{"Opacity", "[", ".5", "]"}]}], "]"}], ",", " ", 
       RowBox[{"Cuboid", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "10"}], ",", " ", 
           RowBox[{"-", "10"}], ",", " ", "4.5"}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"10", ",", " ", "10", ",", " ", "5.5"}], "}"}]}], "]"}]}], 
      "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", " ", 
       RowBox[{"PointSize", "[", ".02", "]"}], ",", " ", "dotsOriginal"}], 
      "}"}]}], "}"}], ",", " ", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", " ", "0", ",", " ", "0"}], "}"}]}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "13"}], ",", " ", "13"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "13"}], ",", " ", "13"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", ".5"}], ",", " ", "8"}], "}"}]}], "}"}]}], ",", " ", 
   RowBox[{"ImageSize", "\[Rule]", "800"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8508317377435584`*^9, 3.8508317387548704`*^9}},
 CellLabel->
  "In[214]:=",ExpressionUUID->"8d8828f8-5ced-4324-826a-fbcde030aad5"],

Cell[BoxData[
 Graphics3DBox[{
   {RGBColor[1, 0, 0], Opacity[0.2], 
    CuboidBox[{-10, -10, 3.5}, {10, 10, 4.5}]}, 
   {RGBColor[0, 0, 1], Opacity[0.1], FaceForm[RGBColor[0, 1, 0], Opacity[0]], 
    CuboidBox[{-10, -10, 2.5}, {10, 10, 3.5}]}, 
   {RGBColor[0, 0, 1], Opacity[0.1], FaceForm[GrayLevel[1], Opacity[0.5]], 
    CuboidBox[{-10, -10, 4.5}, {10, 10, 5.5}]}, 
   {RGBColor[0, 0, 1], PointSize[0.02], Point3DBox[{1, 2, 0}], 
    Point3DBox[{2, 2, 0}], Point3DBox[{1, 1, 0}], Point3DBox[{2, 1, 0}]}},
  AxesOrigin->{0, 0, 0},
  ImageSize->800,
  PlotRange->{{-13, 13}, {-13, 13}, {-0.5, 8}},
  ViewPoint->{3.3751756141840357`, 0.2058669280400198, 0.12573138572679843`},
  ViewVertical->{0.21776729943600104`, -0.010847394552268111`, 
   0.9759404373873328}]], "Output",
 CellChangeTimes->{3.8508317390920553`*^9},
 CellLabel->
  "Out[214]=",ExpressionUUID->"e5f421dd-d7df-48bd-bc00-4cb9ed37ab1f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{
   RowBox[{"{", " ", 
    RowBox[{
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{"Opacity", "[", "0.2", "]"}], ",", " ", "Red", ",", "  ", 
       RowBox[{"Cuboid", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "10"}], ",", " ", 
           RowBox[{"-", "10"}], ",", " ", "3.5"}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"10", ",", " ", "10", ",", " ", "4.5"}], "}"}]}], "]"}]}], 
      "}"}], ",", " ", 
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{"Opacity", "[", "0.1", "]"}], ",", " ", "Blue", ",", " ", 
       RowBox[{"FaceForm", "[", 
        RowBox[{"Green", ",", " ", 
         RowBox[{"Opacity", "[", "0", "]"}]}], "]"}], ",", " ", 
       RowBox[{"Cuboid", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "10"}], ",", " ", 
           RowBox[{"-", "10"}], ",", " ", "2.5"}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"10", ",", " ", "10", ",", " ", "3.5"}], "}"}]}], "]"}]}], 
      "}"}], ",", " ", 
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{"Opacity", "[", "0.1", "]"}], ",", " ", "Blue", ",", " ", 
       RowBox[{"FaceForm", "[", 
        RowBox[{"White", ",", " ", 
         RowBox[{"Opacity", "[", ".5", "]"}]}], "]"}], ",", " ", 
       RowBox[{"Cuboid", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "10"}], ",", " ", 
           RowBox[{"-", "10"}], ",", " ", "4.5"}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"10", ",", " ", "10", ",", " ", "5.5"}], "}"}]}], "]"}]}], 
      "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", " ", 
       RowBox[{"PointSize", "[", ".02", "]"}], ",", " ", "dots"}], "}"}]}], 
    "}"}], ",", " ", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", " ", "0", ",", " ", "0"}], "}"}]}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "13"}], ",", " ", "13"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "13"}], ",", " ", "13"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", ".5"}], ",", " ", "8"}], "}"}]}], "}"}]}], ",", " ", 
   RowBox[{"ImageSize", "\[Rule]", "800"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8508305323637295`*^9, 3.850830807034234*^9}},
 CellLabel->
  "In[207]:=",ExpressionUUID->"cbb42544-c1e0-4acd-b40a-1a655834cfbb"],

Cell[BoxData[
 Graphics3DBox[{
   {RGBColor[1, 0, 0], Opacity[0.2], 
    CuboidBox[{-10, -10, 3.5}, {10, 10, 4.5}]}, 
   {RGBColor[0, 0, 1], Opacity[0.1], FaceForm[RGBColor[0, 1, 0], Opacity[0]], 
    CuboidBox[{-10, -10, 2.5}, {10, 10, 3.5}]}, 
   {RGBColor[0, 0, 1], Opacity[0.1], FaceForm[GrayLevel[1], Opacity[0.5]], 
    CuboidBox[{-10, -10, 4.5}, {10, 10, 5.5}]}, 
   {RGBColor[0, 0, 1], PointSize[0.02], Point3DBox[{-0.25, 0.25, 0}], 
    Point3DBox[{0.25, 0.25, 0}], Point3DBox[{-0.25, -0.25, 0}], 
    Point3DBox[{0.25, -0.25, 0}]}},
  AxesOrigin->{0, 0, 0},
  ImageSize->800,
  ImageSizeRaw->Automatic,
  PlotRange->{{-13, 13}, {-13, 13}, {-0.5, 8}},
  ViewPoint->{3.3747248483237975`, 0.08490771068449487, 0.23242822283932307`},
  ViewVertical->{0.20340821291078767`, 0.0538677273381903, 
   0.977611050915372}]], "Output",
 CellChangeTimes->{{3.850830550535988*^9, 3.8508306262477093`*^9}, {
  3.850830661102038*^9, 3.8508308080400248`*^9}},
 CellLabel->
  "Out[207]=",ExpressionUUID->"f13574bd-c686-485a-87c5-dac833a409a5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{
   RowBox[{"{", " ", 
    RowBox[{
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{"Opacity", "[", "0.2", "]"}], ",", " ", "Red", ",", "  ", 
       RowBox[{"Cuboid", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "10"}], ",", " ", 
           RowBox[{"-", "10"}], ",", " ", "3.5"}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"10", ",", " ", "10", ",", " ", "4.5"}], "}"}]}], "]"}]}], 
      "}"}], ",", " ", 
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{"Opacity", "[", "0.1", "]"}], ",", " ", "Blue", ",", " ", 
       RowBox[{"FaceForm", "[", 
        RowBox[{"Green", ",", " ", 
         RowBox[{"Opacity", "[", "0", "]"}]}], "]"}], ",", " ", 
       RowBox[{"Cuboid", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "10"}], ",", " ", 
           RowBox[{"-", "10"}], ",", " ", "2.5"}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"10", ",", " ", "10", ",", " ", "3.5"}], "}"}]}], "]"}]}], 
      "}"}], ",", " ", 
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{"Opacity", "[", "0.1", "]"}], ",", " ", "Blue", ",", " ", 
       RowBox[{"FaceForm", "[", 
        RowBox[{"White", ",", " ", 
         RowBox[{"Opacity", "[", ".5", "]"}]}], "]"}], ",", " ", 
       RowBox[{"Cuboid", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "10"}], ",", " ", 
           RowBox[{"-", "10"}], ",", " ", "4.5"}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"10", ",", " ", "10", ",", " ", "5.5"}], "}"}]}], "]"}]}], 
      "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", " ", 
       RowBox[{"PointSize", "[", ".02", "]"}], ",", " ", "dotsWide"}], 
      "}"}]}], "}"}], ",", " ", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", " ", "0", ",", " ", "0"}], "}"}]}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "13"}], ",", " ", "13"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "13"}], ",", " ", "13"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", ".5"}], ",", " ", "8"}], "}"}]}], "}"}]}], ",", " ", 
   RowBox[{"ImageSize", "\[Rule]", "800"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8508308963888564`*^9, 3.8508308967121134`*^9}},
 CellLabel->
  "In[212]:=",ExpressionUUID->"bf0f1286-9115-4d7e-8407-d5ecc6647900"],

Cell[BoxData[
 Graphics3DBox[{
   {RGBColor[1, 0, 0], Opacity[0.2], 
    CuboidBox[{-10, -10, 3.5}, {10, 10, 4.5}]}, 
   {RGBColor[0, 0, 1], Opacity[0.1], FaceForm[RGBColor[0, 1, 0], Opacity[0]], 
    CuboidBox[{-10, -10, 2.5}, {10, 10, 3.5}]}, 
   {RGBColor[0, 0, 1], Opacity[0.1], FaceForm[GrayLevel[1], Opacity[0.5]], 
    CuboidBox[{-10, -10, 4.5}, {10, 10, 5.5}]}, 
   {RGBColor[0, 0, 1], PointSize[0.02], Point3DBox[{-2, 2, 0}], 
    Point3DBox[{2, 2, 0}], Point3DBox[{-2, -2, 0}], Point3DBox[{2, -2, 0}]}},
  AxesOrigin->{0, 0, 0},
  ImageSize->800,
  PlotRange->{{-13, 13}, {-13, 13}, {-0.5, 8}},
  ViewPoint->{0.6627076419304244, -3.3078361565634817`, 0.26275186518528804`},
  ViewVertical->{0.06725898709799426, -0.1898049097773016, 
   0.9795153520384364}]], "Output",
 CellChangeTimes->{{3.8508308970481586`*^9, 3.85083091895444*^9}},
 CellLabel->
  "Out[212]=",ExpressionUUID->"c4734eb8-3138-4f51-9aa7-5263a16bea30"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"KeyValueMap", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EdgeForm", "[", "None", "]"}], ",", " ", 
          RowBox[{"Opacity", "[", 
           RowBox[{"#2", " ", "/", " ", "50"}], "]"}], ",", " ", 
          RowBox[{
           RowBox[{"ColorData", "[", 
            RowBox[{"{", 
             RowBox[{"\"\<AvocadoColors\>\"", ",", " ", "\"\<Reverse\>\""}], 
             "}"}], "]"}], "[", 
           RowBox[{"#2", " ", "/", " ", "50"}], "]"}], ",", 
          RowBox[{"cuboidFromBounds", "[", "#1", "]"}]}], "}"}], "  ", "&"}], 
       ",", " ", 
       RowBox[{"Normal", "@", "badGroup"}]}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"White", ",", " ", 
       RowBox[{"Opacity", "[", "0.1", "]"}], ",", " ", 
       RowBox[{"FaceForm", "[", 
        RowBox[{"White", ",", " ", 
         RowBox[{"Opacity", "[", "0", "]"}]}], "]"}], ",", " ", 
       RowBox[{"EdgeForm", "[", 
        RowBox[{"{", 
         RowBox[{"Thick", ",", " ", "Dashed"}], "}"}], "]"}], ",", " ", 
       RowBox[{"Cuboid", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "10"}], ",", " ", 
           RowBox[{"-", "10"}], ",", " ", "3.5"}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"10", ",", " ", "10", ",", " ", "4.5"}], "}"}]}], "]"}]}], 
      "}"}], ",", " ", 
     RowBox[{"dipoleArrow", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"badDipole", "[", "\"\<pd\>\"", "]"}], ",", " ", 
        RowBox[{"badDipole", "[", "\"\<sd\>\"", "]"}]}], "}"}], "]"}], ",", 
     " ", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", " ", 
       RowBox[{"PointSize", "[", ".02", "]"}], ",", " ", "dots"}], "}"}]}], 
    "}"}], ",", " ", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", " ", "0", ",", " ", "0"}], "}"}]}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "13"}], ",", " ", "13"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "13"}], ",", " ", "13"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", ".5"}], ",", " ", "8"}], "}"}]}], "}"}]}], ",", " ", 
   RowBox[{"ImageSize", "\[Rule]", "1000"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8508269744409437`*^9, 3.8508269845954704`*^9}, {
   3.850827049454539*^9, 3.8508270663048906`*^9}, {3.850827177757572*^9, 
   3.8508272493152313`*^9}, {3.8508272846827564`*^9, 
   3.8508272917441025`*^9}, {3.850827876441044*^9, 3.850827878013918*^9}, {
   3.8508279565897512`*^9, 3.8508279945185895`*^9}, 3.850828024806422*^9, {
   3.850828246212096*^9, 3.8508283464071035`*^9}, {3.850828844098428*^9, 
   3.8508288543883476`*^9}, {3.8508303113672895`*^9, 3.850830420770478*^9}, {
   3.850830485320603*^9, 3.850830498016633*^9}, {3.850832768947873*^9, 
   3.850832775928399*^9}},
 CellLabel->
  "In[216]:=",ExpressionUUID->"7ce25d77-d546-4c9c-8c6f-9a3985a20587"],

Cell[BoxData[
 Graphics3DBox[{{
    {RGBColor[0.21988775999999996`, 0.62696748, 0.10063898399999999`], Opacity[
      NCache[
       Rational[14, 25], 0.56]], EdgeForm[None], 
     CuboidBox[{-6., -2., 2.5}, {-2., 2., 2.7}]}, 
    {RGBColor[0.32089904, 0.69677012, 0.11172348], Opacity[
      NCache[
       Rational[12, 25], 0.48]], EdgeForm[None], 
     CuboidBox[{-6., -2., 2.7}, {-2., 2., 2.9}]}, 
    {RGBColor[0.7471911999999999, 0.8615918, 0.1627342], Opacity[
      NCache[
       Rational[1, 5], 0.2]], EdgeForm[None], 
     CuboidBox[{-2., -2., 2.7}, {2., 2., 2.9}]}, 
    {RGBColor[0.6966294399999999, 0.83703516, 0.14919884], Opacity[
      NCache[
       Rational[6, 25], 0.24]], EdgeForm[None], 
     CuboidBox[{-2., -2., 2.9}, {2., 2., 3.1}]}, 
    {RGBColor[0.79775296, 0.8861484399999999, 0.17626956], Opacity[
      NCache[
       Rational[4, 25], 0.16]], EdgeForm[None], 
     CuboidBox[{-2., -2., 3.1}, {2., 2., 3.3}]}, 
    {RGBColor[0.79775296, 0.8861484399999999, 0.17626956], Opacity[
      NCache[
       Rational[4, 25], 0.16]], EdgeForm[None], 
     CuboidBox[{-2., -2., 3.3}, {2., 2., 3.5}]}, 
    {RGBColor[0.79775296, 0.8861484399999999, 0.17626956], Opacity[
      NCache[
       Rational[4, 25], 0.16]], EdgeForm[None], 
     CuboidBox[{-6., -2., 2.9}, {-2., 2., 3.1}]}, 
    {RGBColor[0.79775296, 0.8861484399999999, 0.17626956], Opacity[
      NCache[
       Rational[4, 25], 0.16]], EdgeForm[None], 
     CuboidBox[{-6., -2., 3.1}, {-2., 2., 3.3}]}, 
    {RGBColor[0.79775296, 0.8861484399999999, 0.17626956], Opacity[
      NCache[
       Rational[4, 25], 0.16]], EdgeForm[None], 
     CuboidBox[{-6., -2., 3.3}, {-2., 2., 3.5}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-2., -2., 2.5}, {2., 2., 2.7}]}, 
    {RGBColor[0.79775296, 0.8861484399999999, 0.17626956], Opacity[
      NCache[
       Rational[4, 25], 0.16]], EdgeForm[None], 
     CuboidBox[{-2., -2., 3.5}, {2., 2., 3.7}]}, 
    {RGBColor[0.79775296, 0.8861484399999999, 0.17626956], Opacity[
      NCache[
       Rational[4, 25], 0.16]], EdgeForm[None], 
     CuboidBox[{-2., -2., 3.7}, {2., 2., 3.9}]}, 
    {RGBColor[0.79775296, 0.8861484399999999, 0.17626956], Opacity[
      NCache[
       Rational[4, 25], 0.16]], EdgeForm[None], 
     CuboidBox[{-2., -2., 3.9}, {2., 2., 4.1}]}, 
    {RGBColor[0.79775296, 0.8861484399999999, 0.17626956], Opacity[
      NCache[
       Rational[4, 25], 0.16]], EdgeForm[None], 
     CuboidBox[{-6., -2., 3.5}, {-2., 2., 3.7}]}, 
    {RGBColor[0.79775296, 0.8861484399999999, 0.17626956], Opacity[
      NCache[
       Rational[4, 25], 0.16]], EdgeForm[None], 
     CuboidBox[{-6., -2., 3.7}, {-2., 2., 3.9}]}, 
    {RGBColor[0.94943824, 0.95981836, 0.21687564], Opacity[
      NCache[
       Rational[1, 25], 0.04]], EdgeForm[None], 
     CuboidBox[{-6., -2., 3.9}, {-2., 2., 4.1}]}}, 
   {GrayLevel[1], Opacity[0.1], EdgeForm[{Thickness[Large], 
    Dashing[{Small, Small}]}], FaceForm[{}, Opacity[0]], 
    CuboidBox[{-10, -10, 3.5}, {10, 10, 4.5}]}, 
   Arrow3DBox[{{-1.8204699606457453`, 0.46178206204345074`, 
    3.8691572159777703`}, {-1.0750800478731097`, 0.4060059809823242, 
    8.168635817676368}}], 
   {RGBColor[0, 0, 1], PointSize[0.02], Point3DBox[{-0.25, 0.25, 0}], 
    Point3DBox[{0.25, 0.25, 0}], Point3DBox[{-0.25, -0.25, 0}], 
    Point3DBox[{0.25, -0.25, 0}]}},
  AxesOrigin->{0, 0, 0},
  ImageSize->1000,
  ImageSizeRaw->Automatic,
  PlotRange->{{-13, 13}, {-13, 13}, {-0.5, 8}},
  ViewPoint->{-0.038783875818441345`, 3.383495904942798, 
   0.021243168591592705`},
  ViewVertical->{-0.054711794354451594`, 0.21375812456023208`, 
   0.9753533122633093}]], "Output",
 CellChangeTimes->{{3.8508269803584085`*^9, 3.850826984841661*^9}, {
   3.8508270668906837`*^9, 3.850827076523182*^9}, {3.850827187530077*^9, 
   3.850827217305703*^9}, 3.850827249677412*^9, 3.8508272920723743`*^9, 
   3.8508278784157734`*^9, 3.850827985257457*^9, 3.8508280260831013`*^9, {
   3.8508282608028917`*^9, 3.850828311971316*^9}, 3.8508283469917684`*^9, {
   3.850828845377279*^9, 3.850828855369573*^9}, {3.85083031307101*^9, 
   3.8508304211915684`*^9}, {3.8508304894377804`*^9, 3.8508304984523*^9}, {
   3.8508327730324183`*^9, 3.8508327762582884`*^9}},
 CellLabel->
  "Out[216]=",ExpressionUUID->"5b947c20-6ba0-494b-a565-51a91ecc3bbe"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.8508270820312667`*^9, 
  3.8508270825881443`*^9}},ExpressionUUID->"e5ba1b37-0a66-45a4-9192-\
bf9bb487c712"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"KeyValueMap", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EdgeForm", "[", "None", "]"}], ",", " ", 
          RowBox[{"Opacity", "[", 
           RowBox[{"#2", " ", "/", " ", "50"}], "]"}], ",", " ", 
          RowBox[{
           RowBox[{"ColorData", "[", 
            RowBox[{"{", 
             RowBox[{"\"\<AvocadoColors\>\"", ",", " ", "\"\<Reverse\>\""}], 
             "}"}], "]"}], "[", 
           RowBox[{"#2", " ", "/", " ", "50"}], "]"}], ",", 
          RowBox[{"cuboidFromBounds", "[", "#1", "]"}]}], "}"}], "  ", "&"}], 
       ",", " ", 
       RowBox[{"Normal", "@", "goodGroup"}]}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"White", ",", " ", 
       RowBox[{"Opacity", "[", "0", "]"}], ",", " ", 
       RowBox[{"FaceForm", "[", 
        RowBox[{"White", ",", " ", 
         RowBox[{"Opacity", "[", ".2", "]"}]}], "]"}], ",", " ", 
       RowBox[{"EdgeForm", "[", 
        RowBox[{"{", 
         RowBox[{"Thick", ",", " ", "Dashed"}], "}"}], "]"}], ",", " ", 
       RowBox[{"Cuboid", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "10"}], ",", " ", 
           RowBox[{"-", "10"}], ",", " ", "3.5"}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"10", ",", " ", "10", ",", " ", "4.5"}], "}"}]}], "]"}]}], 
      "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", " ", 
       RowBox[{"PointSize", "[", ".02", "]"}], ",", " ", "dots"}], "}"}], ",",
      " ", 
     RowBox[{"dipoleArrow", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"goodDipole", "[", "\"\<pd\>\"", "]"}], ",", " ", 
        RowBox[{"goodDipole", "[", "\"\<sd\>\"", "]"}]}], "}"}], "]"}]}], 
    "}"}], ",", " ", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", " ", "0", ",", " ", "0"}], "}"}]}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "13"}], ",", " ", "13"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "13"}], ",", " ", "13"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", ".5"}], ",", " ", "8"}], "}"}]}], "}"}]}], ",", " ", 
   RowBox[{"ImageSize", "\[Rule]", "1000"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.850828096359398*^9, 3.8508281068013916`*^9}, {
  3.850828367805627*^9, 3.8508283844346495`*^9}, {3.8508284935464106`*^9, 
  3.8508287642100286`*^9}, {3.850828798902051*^9, 3.8508288065056367`*^9}, {
  3.8508304425334277`*^9, 3.8508304744135656`*^9}, {3.8508329292229633`*^9, 
  3.850832934261269*^9}},
 CellLabel->
  "In[218]:=",ExpressionUUID->"9521353b-171a-4831-a767-3933f45e6a81"],

Cell[BoxData[
 Graphics3DBox[{{
    {RGBColor[0.51033728, 0.76674884, 0.12951036], Opacity[
      NCache[
       Rational[9, 25], 0.36]], EdgeForm[None], 
     CuboidBox[{-2., -6., 2.7}, {2., -2., 2.9}]}, 
    {RGBColor[0.51033728, 0.76674884, 0.12951036], Opacity[
      NCache[
       Rational[9, 25], 0.36]], EdgeForm[None], 
     CuboidBox[{-2., -6., 2.9}, {2., -2., 3.1}]}, 
    {RGBColor[0.51033728, 0.76674884, 0.12951036], Opacity[
      NCache[
       Rational[9, 25], 0.36]], EdgeForm[None], 
     CuboidBox[{-2., -6., 3.1}, {2., -2., 3.3}]}, 
    {RGBColor[0.51033728, 0.76674884, 0.12951036], Opacity[
      NCache[
       Rational[9, 25], 0.36]], EdgeForm[None], 
     CuboidBox[{-2., -6., 3.3}, {2., -2., 3.5}]}, 
    {RGBColor[0.6966294399999999, 0.83703516, 0.14919884], Opacity[
      NCache[
       Rational[6, 25], 0.24]], EdgeForm[None], 
     CuboidBox[{-6., -6., 2.5}, {-2., -2., 2.7}]}, 
    {RGBColor[0.6966294399999999, 0.83703516, 0.14919884], Opacity[
      NCache[
       Rational[6, 25], 0.24]], EdgeForm[None], 
     CuboidBox[{-6., -6., 2.7}, {-2., -2., 2.9}]}, 
    {RGBColor[0.79775296, 0.8861484399999999, 0.17626956], Opacity[
      NCache[
       Rational[4, 25], 0.16]], EdgeForm[None], 
     CuboidBox[{-6., -6., 2.9}, {-2., -2., 3.1}]}, 
    {RGBColor[0.84831472, 0.91070508, 0.18980492], Opacity[
      NCache[
       Rational[3, 25], 0.12]], EdgeForm[None], 
     CuboidBox[{-6., -6., 3.1}, {-2., -2., 3.3}]}, 
    {RGBColor[0.84831472, 0.91070508, 0.18980492], Opacity[
      NCache[
       Rational[3, 25], 0.12]], EdgeForm[None], 
     CuboidBox[{-6., -2., 2.5}, {-2., 2., 2.7}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-6., -2., 2.7}, {-2., 2., 2.9}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-6., -2., 2.9}, {-2., 2., 3.1}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-6., -2., 3.1}, {-2., 2., 3.3}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-6., -6., 3.3}, {-2., -2., 3.5}]}, 
    {RGBColor[0.51033728, 0.76674884, 0.12951036], Opacity[
      NCache[
       Rational[9, 25], 0.36]], EdgeForm[None], 
     CuboidBox[{-2., -6., 2.5}, {2., -2., 2.7}]}, 
    {RGBColor[0.38404512, 0.72009636, 0.11765244], Opacity[
      NCache[
       Rational[11, 25], 0.44]], EdgeForm[None], 
     CuboidBox[{2., -6., 2.5}, {6., -2., 2.7}]}, 
    {RGBColor[0.32089904, 0.69677012, 0.11172348], Opacity[
      NCache[
       Rational[12, 25], 0.48]], EdgeForm[None], 
     CuboidBox[{2., -6., 2.7}, {6., -2., 2.9}]}, 
    {RGBColor[0.38404512, 0.72009636, 0.11765244], Opacity[
      NCache[
       Rational[11, 25], 0.44]], EdgeForm[None], 
     CuboidBox[{2., -6., 2.9}, {6., -2., 3.1}]}, 
    {RGBColor[0.38404512, 0.72009636, 0.11765244], Opacity[
      NCache[
       Rational[11, 25], 0.44]], EdgeForm[None], 
     CuboidBox[{2., -6., 3.1}, {6., -2., 3.3}]}, 
    {RGBColor[0.26617992, 0.66572716, 0.10605232799999999`], Opacity[
      NCache[
       Rational[13, 25], 0.52]], EdgeForm[None], 
     CuboidBox[{2., -6., 3.3}, {6., -2., 3.5}]}, 
    {RGBColor[0.51033728, 0.76674884, 0.12951036], Opacity[
      NCache[
       Rational[9, 25], 0.36]], EdgeForm[None], 
     CuboidBox[{2., -2., 2.5}, {6., 2., 2.7}]}, 
    {RGBColor[0.51033728, 0.76674884, 0.12951036], Opacity[
      NCache[
       Rational[9, 25], 0.36]], EdgeForm[None], 
     CuboidBox[{2., -2., 2.7}, {6., 2., 2.9}]}, 
    {RGBColor[0.47876423999999995`, 0.75508572, 0.12654588], Opacity[
      NCache[
       Rational[19, 50], 0.38]], EdgeForm[None], 
     CuboidBox[{2., -2., 2.9}, {6., 2., 3.1}]}, 
    {RGBColor[0.57348336, 0.7900750799999999, 0.13543932], Opacity[
      NCache[
       Rational[8, 25], 0.32]], EdgeForm[None], 
     CuboidBox[{2., -2., 3.1}, {6., 2., 3.3}]}, 
    {RGBColor[0.57348336, 0.7900750799999999, 0.13543932], Opacity[
      NCache[
       Rational[8, 25], 0.32]], EdgeForm[None], 
     CuboidBox[{2., -2., 3.3}, {6., 2., 3.5}]}, 
    {RGBColor[0.7471911999999999, 0.8615918, 0.1627342], Opacity[
      NCache[
       Rational[1, 5], 0.2]], EdgeForm[None], 
     CuboidBox[{2., 2., 2.5}, {6., 6., 2.7}]}, 
    {RGBColor[0.7471911999999999, 0.8615918, 0.1627342], Opacity[
      NCache[
       Rational[1, 5], 0.2]], EdgeForm[None], 
     CuboidBox[{2., 2., 2.7}, {6., 6., 2.9}]}, 
    {RGBColor[0.94943824, 0.95981836, 0.21687564], Opacity[
      NCache[
       Rational[1, 25], 0.04]], EdgeForm[None], 
     CuboidBox[{-6., -2., 3.3}, {-2., 2., 3.5}]}, 
    {RGBColor[0.6966294399999999, 0.83703516, 0.14919884], Opacity[
      NCache[
       Rational[6, 25], 0.24]], EdgeForm[None], 
     CuboidBox[{-2., -2., 3.3}, {2., 2., 3.5}]}, 
    {RGBColor[0.94943824, 0.95981836, 0.21687564], Opacity[
      NCache[
       Rational[1, 25], 0.04]], EdgeForm[None], 
     CuboidBox[{2., -10., 2.5}, {6., -6., 2.7}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{2., -10., 2.7}, {6., -6., 2.9}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{2., -10., 2.9}, {6., -6., 3.1}]}, 
    {RGBColor[0.79775296, 0.8861484399999999, 0.17626956], Opacity[
      NCache[
       Rational[4, 25], 0.16]], EdgeForm[None], 
     CuboidBox[{-2., 2., 3.3}, {2., 6., 3.5}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{2., -10., 3.3}, {6., -6., 3.5}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{2., 2., 2.9}, {6., 6., 3.1}]}, 
    {RGBColor[0.84831472, 0.91070508, 0.18980492], Opacity[
      NCache[
       Rational[3, 25], 0.12]], EdgeForm[None], 
     CuboidBox[{2., 2., 3.1}, {6., 6., 3.3}]}, 
    {RGBColor[0.94943824, 0.95981836, 0.21687564], Opacity[
      NCache[
       Rational[1, 25], 0.04]], EdgeForm[None], 
     CuboidBox[{2., 2., 3.3}, {6., 6., 3.5}]}, 
    {RGBColor[0.84831472, 0.91070508, 0.18980492], Opacity[
      NCache[
       Rational[3, 25], 0.12]], EdgeForm[None], 
     CuboidBox[{-2., 2., 2.5}, {2., 6., 2.7}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-2., 2., 2.7}, {2., 6., 2.9}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-2., 2., 2.9}, {2., 6., 3.1}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-2., 2., 3.1}, {2., 6., 3.3}]}, 
    {RGBColor[0.79775296, 0.8861484399999999, 0.17626956], Opacity[
      NCache[
       Rational[4, 25], 0.16]], EdgeForm[None], 
     CuboidBox[{-2., -2., 3.1}, {2., 2., 3.3}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-2., -2., 2.5}, {2., 2., 2.7}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-2., -2., 2.7}, {2., 2., 2.9}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-2., -2., 2.9}, {2., 2., 3.1}]}, 
    {RGBColor[0.94943824, 0.95981836, 0.21687564], Opacity[
      NCache[
       Rational[1, 25], 0.04]], EdgeForm[None], 
     CuboidBox[{2., -10., 3.1}, {6., -6., 3.3}]}, 
    {RGBColor[0.32089904, 0.69677012, 0.11172348], Opacity[
      NCache[
       Rational[12, 25], 0.48]], EdgeForm[None], 
     CuboidBox[{-2., -6., 3.5}, {2., -2., 3.7}]}, 
    {RGBColor[0.26617992, 0.66572716, 0.10605232799999999`], Opacity[
      NCache[
       Rational[13, 25], 0.52]], EdgeForm[None], 
     CuboidBox[{-2., -6., 3.7}, {2., -2., 3.9}]}, 
    {RGBColor[0.21988775999999996`, 0.62696748, 0.10063898399999999`], Opacity[
      NCache[
       Rational[14, 25], 0.56]], EdgeForm[None], 
     CuboidBox[{-2., -6., 3.9}, {2., -2., 4.1}]}, 
    {RGBColor[0.26617992, 0.66572716, 0.10605232799999999`], Opacity[
      NCache[
       Rational[13, 25], 0.52]], EdgeForm[None], 
     CuboidBox[{-2., -6., 4.1}, {2., -2., 4.3}]}, 
    {RGBColor[0.26617992, 0.66572716, 0.10605232799999999`], Opacity[
      NCache[
       Rational[13, 25], 0.52]], EdgeForm[None], 
     CuboidBox[{-2., -6., 4.3}, {2., -2., 4.5}]}, 
    {RGBColor[0.26617992, 0.66572716, 0.10605232799999999`], Opacity[
      NCache[
       Rational[13, 25], 0.52]], EdgeForm[None], 
     CuboidBox[{2., -2., 4.3}, {6., 2., 4.5}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-6., -6., 3.5}, {-2., -2., 3.7}]}, 
    {RGBColor[0.94943824, 0.95981836, 0.21687564], Opacity[
      NCache[
       Rational[1, 25], 0.04]], EdgeForm[None], 
     CuboidBox[{-6., -6., 3.7}, {-2., -2., 3.9}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-6., -2., 3.5}, {-2., 2., 3.7}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-6., -2., 3.7}, {-2., 2., 3.9}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-6., -2., 3.9}, {-2., 2., 4.1}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-6., -2., 4.1}, {-2., 2., 4.3}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-6., -2., 4.3}, {-2., 2., 4.5}]}, 
    {RGBColor[0.44719119999999996`, 0.7434225999999999, 0.1235814], Opacity[
      NCache[
       Rational[2, 5], 0.4]], EdgeForm[None], 
     CuboidBox[{-2., -2., 3.7}, {2., 2., 3.9}]}, 
    {RGBColor[0.44719119999999996`, 0.7434225999999999, 0.1235814], Opacity[
      NCache[
       Rational[2, 5], 0.4]], EdgeForm[None], 
     CuboidBox[{-2., -2., 3.9}, {2., 2., 4.1}]}, 
    {RGBColor[0.32089904, 0.69677012, 0.11172348], Opacity[
      NCache[
       Rational[12, 25], 0.48]], EdgeForm[None], 
     CuboidBox[{-2., -2., 4.1}, {2., 2., 4.3}]}, 
    {RGBColor[0.26617992, 0.66572716, 0.10605232799999999`], Opacity[
      NCache[
       Rational[13, 25], 0.52]], EdgeForm[None], 
     CuboidBox[{-2., -2., 4.3}, {2., 2., 4.5}]}, 
    {RGBColor[0.51033728, 0.76674884, 0.12951036], Opacity[
      NCache[
       Rational[9, 25], 0.36]], EdgeForm[None], 
     CuboidBox[{2., -6., 4.1}, {6., -2., 4.3}]}, 
    {RGBColor[0.38404512, 0.72009636, 0.11765244], Opacity[
      NCache[
       Rational[11, 25], 0.44]], EdgeForm[None], 
     CuboidBox[{2., -2., 3.7}, {6., 2., 3.9}]}, 
    {RGBColor[0.32089904, 0.69677012, 0.11172348], Opacity[
      NCache[
       Rational[12, 25], 0.48]], EdgeForm[None], 
     CuboidBox[{2., -2., 3.9}, {6., 2., 4.1}]}, 
    {RGBColor[0.32089904, 0.69677012, 0.11172348], Opacity[
      NCache[
       Rational[12, 25], 0.48]], EdgeForm[None], 
     CuboidBox[{2., -2., 4.1}, {6., 2., 4.3}]}, 
    {RGBColor[0.94943824, 0.95981836, 0.21687564], Opacity[
      NCache[
       Rational[1, 25], 0.04]], EdgeForm[None], 
     CuboidBox[{-6., -6., 4.3}, {-2., -2., 4.5}]}, 
    {RGBColor[0.26617992, 0.66572716, 0.10605232799999999`], Opacity[
      NCache[
       Rational[13, 25], 0.52]], EdgeForm[None], 
     CuboidBox[{2., -6., 3.5}, {6., -2., 3.7}]}, 
    {RGBColor[0.32089904, 0.69677012, 0.11172348], Opacity[
      NCache[
       Rational[12, 25], 0.48]], EdgeForm[None], 
     CuboidBox[{2., -6., 3.7}, {6., -2., 3.9}]}, 
    {RGBColor[0.44719119999999996`, 0.7434225999999999, 0.1235814], Opacity[
      NCache[
       Rational[2, 5], 0.4]], EdgeForm[None], 
     CuboidBox[{2., -6., 3.9}, {6., -2., 4.1}]}, 
    {RGBColor[0.57348336, 0.7900750799999999, 0.13543932], Opacity[
      NCache[
       Rational[8, 25], 0.32]], EdgeForm[None], 
     CuboidBox[{2., -2., 3.5}, {6., 2., 3.7}]}, 
    {RGBColor[0.79775296, 0.8861484399999999, 0.17626956], Opacity[
      NCache[
       Rational[4, 25], 0.16]], EdgeForm[None], 
     CuboidBox[{2., -6., 4.3}, {6., -2., 4.5}]}, 
    {RGBColor[0.6366294399999999, 0.81340132, 0.14136827999999999`], Opacity[
      NCache[
       Rational[7, 25], 0.28]], EdgeForm[None], 
     CuboidBox[{-2., -2., 3.5}, {2., 2., 3.7}]}, 
    {RGBColor[0.79775296, 0.8861484399999999, 0.17626956], Opacity[
      NCache[
       Rational[4, 25], 0.16]], EdgeForm[None], 
     CuboidBox[{-2., 2., 3.5}, {2., 6., 3.7}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-2., 2., 3.7}, {2., 6., 3.9}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-2., 2., 3.9}, {2., 6., 4.1}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-2., 2., 4.1}, {2., 6., 4.3}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-2., 2., 4.3}, {2., 6., 4.5}]}, 
    {RGBColor[0.94943824, 0.95981836, 0.21687564], Opacity[
      NCache[
       Rational[1, 25], 0.04]], EdgeForm[None], 
     CuboidBox[{2., 2., 3.5}, {6., 6., 3.7}]}, 
    {RGBColor[0.94943824, 0.95981836, 0.21687564], Opacity[
      NCache[
       Rational[1, 25], 0.04]], EdgeForm[None], 
     CuboidBox[{2., 2., 3.7}, {6., 6., 3.9}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-6., -2., 4.5}, {-2., 2., 4.7}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{-6., -2., 4.7}, {-2., 2., 4.9}]}, 
    {RGBColor[0.26617992, 0.66572716, 0.10605232799999999`], Opacity[
      NCache[
       Rational[13, 25], 0.52]], EdgeForm[None], 
     CuboidBox[{-2., -6., 4.5}, {2., -2., 4.7}]}, 
    {RGBColor[0.38404512, 0.72009636, 0.11765244], Opacity[
      NCache[
       Rational[11, 25], 0.44]], EdgeForm[None], 
     CuboidBox[{-2., -6., 4.7}, {2., -2., 4.9}]}, 
    {RGBColor[0.32089904, 0.69677012, 0.11172348], Opacity[
      NCache[
       Rational[12, 25], 0.48]], EdgeForm[None], 
     CuboidBox[{-2., -2., 4.5}, {2., 2., 4.7}]}, 
    {RGBColor[0.26617992, 0.66572716, 0.10605232799999999`], Opacity[
      NCache[
       Rational[13, 25], 0.52]], EdgeForm[None], 
     CuboidBox[{-2., -2., 4.7}, {2., 2., 4.9}]}, 
    {RGBColor[0.32089904, 0.69677012, 0.11172348], Opacity[
      NCache[
       Rational[12, 25], 0.48]], EdgeForm[None], 
     CuboidBox[{-2., -2., 4.9}, {2., 2., 5.1}]}, 
    {RGBColor[0.51033728, 0.76674884, 0.12951036], Opacity[
      NCache[
       Rational[9, 25], 0.36]], EdgeForm[None], 
     CuboidBox[{-2., -6., 4.9}, {2., -2., 5.1}]}, 
    {RGBColor[0.57348336, 0.7900750799999999, 0.13543932], Opacity[
      NCache[
       Rational[8, 25], 0.32]], EdgeForm[None], 
     CuboidBox[{-2., -6., 5.1}, {2., -2., 5.3}]}, 
    {RGBColor[0.6966294399999999, 0.83703516, 0.14919884], Opacity[
      NCache[
       Rational[6, 25], 0.24]], EdgeForm[None], 
     CuboidBox[{-2., -6., 5.3}, {2., -2., 5.5}]}, 
    {RGBColor[0.44719119999999996`, 0.7434225999999999, 0.1235814], Opacity[
      NCache[
       Rational[2, 5], 0.4]], EdgeForm[None], 
     CuboidBox[{2., -2., 4.5}, {6., 2., 4.7}]}, 
    {RGBColor[0.6966294399999999, 0.83703516, 0.14919884], Opacity[
      NCache[
       Rational[6, 25], 0.24]], EdgeForm[None], 
     CuboidBox[{2., -6., 4.5}, {6., -2., 4.7}]}, 
    {RGBColor[0.51033728, 0.76674884, 0.12951036], Opacity[
      NCache[
       Rational[9, 25], 0.36]], EdgeForm[None], 
     CuboidBox[{2., -2., 4.7}, {6., 2., 4.9}]}, 
    {RGBColor[0.6966294399999999, 0.83703516, 0.14919884], Opacity[
      NCache[
       Rational[6, 25], 0.24]], EdgeForm[None], 
     CuboidBox[{2., -2., 4.9}, {6., 2., 5.1}]}, 
    {RGBColor[0.7471911999999999, 0.8615918, 0.1627342], Opacity[
      NCache[
       Rational[1, 5], 0.2]], EdgeForm[None], 
     CuboidBox[{2., -2., 5.1}, {6., 2., 5.3}]}, 
    {RGBColor[0.6966294399999999, 0.83703516, 0.14919884], Opacity[
      NCache[
       Rational[6, 25], 0.24]], EdgeForm[None], 
     CuboidBox[{2., -2., 5.3}, {6., 2., 5.5}]}, 
    {RGBColor[0.51033728, 0.76674884, 0.12951036], Opacity[
      NCache[
       Rational[9, 25], 0.36]], EdgeForm[None], 
     CuboidBox[{-2., -2., 5.1}, {2., 2., 5.3}]}, 
    {RGBColor[0.6966294399999999, 0.83703516, 0.14919884], Opacity[
      NCache[
       Rational[6, 25], 0.24]], EdgeForm[None], 
     CuboidBox[{-2., -2., 5.3}, {2., 2., 5.5}]}, 
    {RGBColor[0.84831472, 0.91070508, 0.18980492], Opacity[
      NCache[
       Rational[3, 25], 0.12]], EdgeForm[None], 
     CuboidBox[{2., -6., 5.1}, {6., -2., 5.3}]}, 
    {RGBColor[0.89887648, 0.93526172, 0.20334028], Opacity[
      NCache[
       Rational[2, 25], 0.08]], EdgeForm[None], 
     CuboidBox[{2., -6., 5.3}, {6., -2., 5.5}]}, 
    {RGBColor[0.7471911999999999, 0.8615918, 0.1627342], Opacity[
      NCache[
       Rational[1, 5], 0.2]], EdgeForm[None], 
     CuboidBox[{2., -6., 4.7}, {6., -2., 4.9}]}, 
    {RGBColor[0.7471911999999999, 0.8615918, 0.1627342], Opacity[
      NCache[
       Rational[1, 5], 0.2]], EdgeForm[None], 
     CuboidBox[{2., -6., 4.9}, {6., -2., 5.1}]}}, 
   {GrayLevel[1], Opacity[0], EdgeForm[{Thickness[Large], 
    Dashing[{Small, Small}]}], FaceForm[{}, Opacity[0.2]], 
    CuboidBox[{-10, -10, 3.5}, {10, 10, 4.5}]}, 
   {RGBColor[0, 0, 1], PointSize[0.02], Point3DBox[{-0.25, 0.25, 0}], 
    Point3DBox[{0.25, 0.25, 0}], Point3DBox[{-0.25, -0.25, 0}], 
    Point3DBox[{0.25, -0.25, 0}]}, 
   Arrow3DBox[{{-1.8204699606457453`, 0.46178206204345074`, 
    3.8691572159777703`}, {-1.0750800478731097`, 0.4060059809823242, 
    8.168635817676368}}]},
  AxesOrigin->{0, 0, 0},
  ImageSize->1000,
  ImageSizeRaw->Automatic,
  PlotRange->{{-13, 13}, {-13, 13}, {-0.5, 8}},
  ViewPoint->{-3.235949256595701, 0.673806378109601, 0.7243047518528012},
  ViewVertical->{-0.1315503310752776, -0.003047991982108302, 
   0.9913048068777139}]], "Output",
 CellChangeTimes->{
  3.8508281076115284`*^9, {3.850828369691454*^9, 3.8508283853651533`*^9}, {
   3.8508285112291527`*^9, 3.850828566990749*^9}, {3.8508286246939898`*^9, 
   3.8508286849116364`*^9}, {3.850828718776039*^9, 3.85082876455179*^9}, 
   3.850828807054891*^9, {3.8508304436314917`*^9, 3.8508304748994837`*^9}, {
   3.850832931733156*^9, 3.8508329348229356`*^9}},
 CellLabel->
  "Out[218]=",ExpressionUUID->"4771bdb3-37b2-4289-bca0-79e143701936"]
}, Open  ]]
},
WindowSize->{1901, 1021},
WindowMargins->{{Automatic, -1963}, {Automatic, 106}},
FrontEndVersion->"12.1 for Microsoft Windows (64-bit) (June 19, 2020)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"a0772fcc-27c2-4f4f-a9af-051717ae5f32"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 250, 4, 28, "Input",ExpressionUUID->"25fb2a79-f694-449f-8bd5-bfad109c1593"],
Cell[833, 28, 179, 2, 32, "Output",ExpressionUUID->"edacc9d0-7054-4bc8-ac81-94fb2d07397e"]
}, Open  ]],
Cell[1027, 33, 550, 14, 28, "Input",ExpressionUUID->"eb864b7f-a31b-4a1b-8fa1-d98f247d2bbe"],
Cell[1580, 49, 381, 8, 28, "Input",ExpressionUUID->"bc43f605-3de9-4aef-8725-dde23442fda8"],
Cell[1964, 59, 2865, 71, 48, "Input",ExpressionUUID->"5d5515b2-0f43-46c1-b8f7-6247d72c4e09"],
Cell[4832, 132, 7368, 159, 219, "Input",ExpressionUUID->"fd4d50bf-f23f-4148-9e56-ba53a1bc4a03"],
Cell[12203, 293, 453, 11, 28, "Input",ExpressionUUID->"fafb3592-acf6-4c30-b778-95cee2b80492"],
Cell[CellGroupData[{
Cell[12681, 308, 416, 8, 28, "Input",ExpressionUUID->"399d6d03-9281-42ab-ab9a-0a36ee548ab7"],
Cell[13100, 318, 185373, 3478, 601, "Output",ExpressionUUID->"be48509f-3a83-4125-a7a4-a68d3e7cd87d"]
}, Open  ]],
Cell[198488, 3799, 2129, 48, 48, "Input",ExpressionUUID->"4d1565da-7ee5-4a2d-9d57-9887b55a1112"],
Cell[200620, 3849, 1084, 31, 48, "Input",ExpressionUUID->"aa9a0a43-39c2-4bf4-84c5-eb7a7967aa21"],
Cell[201707, 3882, 940, 27, 48, "Input",ExpressionUUID->"1a81109c-458d-44a7-8bcc-34fa83e04c71"],
Cell[CellGroupData[{
Cell[202672, 3913, 977, 29, 28, "Input",ExpressionUUID->"00fc9902-1f9b-4741-86cb-83786c3156e8"],
Cell[203652, 3944, 742, 21, 32, "Output",ExpressionUUID->"31674224-2ec9-4f15-ba1b-1b9b5c9556eb"]
}, Open  ]],
Cell[204409, 3968, 721, 19, 28, "Input",ExpressionUUID->"f44036f4-85a6-40c9-94c6-c6cef163a563"],
Cell[CellGroupData[{
Cell[205155, 3991, 2560, 69, 48, "Input",ExpressionUUID->"8d8828f8-5ced-4324-826a-fbcde030aad5"],
Cell[207718, 4062, 905, 18, 336, "Output",ExpressionUUID->"e5f421dd-d7df-48bd-bc00-4cb9ed37ab1f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[208660, 4085, 2548, 69, 48, "Input",ExpressionUUID->"cbb42544-c1e0-4acd-b40a-1a655834cfbb"],
Cell[211211, 4156, 1036, 21, 386, "Output",ExpressionUUID->"f13574bd-c686-485a-87c5-dac833a409a5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[212284, 4182, 2556, 69, 48, "Input",ExpressionUUID->"bf0f1286-9115-4d7e-8407-d5ecc6647900"],
Cell[214843, 4253, 929, 18, 348, "Output",ExpressionUUID->"c4734eb8-3138-4f51-9aa7-5263a16bea30"]
}, Open  ]],
Cell[CellGroupData[{
Cell[215809, 4276, 3094, 76, 67, "Input",ExpressionUUID->"7ce25d77-d546-4c9c-8c6f-9a3985a20587"],
Cell[218906, 4354, 4374, 92, 484, "Output",ExpressionUUID->"5b947c20-6ba0-494b-a565-51a91ecc3bbe"]
}, Open  ]],
Cell[223295, 4449, 156, 3, 28, "Input",ExpressionUUID->"e5ba1b37-0a66-45a4-9192-bf9bb487c712"],
Cell[CellGroupData[{
Cell[223476, 4456, 2818, 72, 67, "Input",ExpressionUUID->"9521353b-171a-4831-a767-3933f45e6a81"],
Cell[226297, 4530, 19311, 433, 576, "Output",ExpressionUUID->"4771bdb3-37b2-4289-bca0-79e143701936"]
}, Open  ]]
}
]
*)

